#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 17 "lexgrog.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 141
#define YY_END_OF_BUFFER 142
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1607] =
    {   0,
        0,    0,    0,    0,   67,   67,   67,   67,    0,    0,
        0,    0,    0,    0,    0,    0,  119,  119,    0,    0,
        0,    0,    0,    0,  126,  126,    8,    8,    0,    0,
        0,    0,    0,    0,    0,    0,  142,  141,   29,   29,
       29,  140,   67,   67,  140,  140,  140,  138,  140,  136,
       83,   67,   67,  140,   83,  106,  106,  106,  101,  106,
      108,  108,  107,  113,  113,  113,  112,  118,  118,  118,
      118,  118,  119,  121,  121,  120,  123,  123,  122,  125,
      125,  124,  126,  126,  140,  137,  140,  140,  140,    7,
       10,    7,    7,    6,    6,    6,    4,   18,   18,   18,

       19,   19,    0,   28,    0,   27,   27,   29,   67,    0,
      138,    0,    0,  139,   67,   67,  139,  135,  139,  139,
      135,   83,   67,    0,    0,  138,    0,  136,   70,   67,
       76,    0,   62,    0,    0,   64,   66,    0,    0,   61,
       63,   61,    0,    0,    0,    0,    0,    0,   67,    0,
       67,   67,  139,  135,   83,   67,    0,   64,    0,  106,
        0,    0,  101,   94,   95,   96,   97,   98,   99,  100,
      108,  107,  113,    0,    0,    0,  112,  112,  118,    0,
        0,    0,  119,  121,  120,  123,  122,  125,  124,  126,
      137,    0,    0,  126,  126,  139,  139,  139,  139,  126,

      137,   54,    0,  126,   39,    7,    0,    9,    0,   10,
        7,    6,    0,    3,    4,    3,    4,    3,   18,    0,
        0,    0,   18,   19,   28,    0,    0,    0,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   57,    0,
        0,   67,    0,    0,   36,   36,   36,   36,   36,   36,
       36,   36,    0,   50,    0,    0,    0,    0,    0,    0,
      130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   48,    0,   57,    0,   49,    0,   58,   76,
       72,    0,    0,    0,    0,    0,    0,    0,    0,   75,
       75,   75,    0,    0,    0,    0,    0,    0,   69,    0,

       77,   78,    0,   79,    0,    0,   81,    0,    0,   67,
        0,    0,   36,   36,   36,   36,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       93,  102,  103,  104,  105,  101,   94,   95,   96,   97,
       98,   99,  100,    0,    0,    0,    0,    0,    0,   60,
        0,  126,   38,   38,  126,   38,   38,   38,   38,   37,
       54,    7,    0,    0,    0,    9,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    7,    5,    3,    3,    4,
        4,    4,    3,    0,    0,    0,    0,    0,   16,    0,

       21,   27,   27,   27,   27,   20,   27,   27,   27,   57,
        0,    0,    0,    0,    0,    0,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   51,   41,    0,    0,    0,
        0,    0,  128,   59,    0,  130,   47,  129,    0,    0,
       30,    0,    0,    0,  127,   34,   53,    0,   35,   33,
       52,   32,    0,    0,    0,   49,   84,   73,   62,   55,

       63,   68,    0,    0,    0,    0,    0,    0,    0,    0,
        0,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   85,    0,   87,   92,   88,   89,   90,
       91,    0,    0,    0,   64,    0,   93,  102,  103,  104,
      105,    0,    0,    0,  116,  114,    0,   38,   38,   38,
       38,   37,   38,   38,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    5,    3,    3,    4,    4,
        4,    0,    3,    3,   12,   14,   13,   15,   11,   17,

       21,   25,   26,   20,   22,   24,   23,   55,    0,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   30,   36,
       36,   36,   36,   34,   36,   36,   35,   33,   36,   32,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   40,  132,
      131,   45,  128,   59,   46,   47,  129,  134,  133,   30,
       42,   44,   31,  127,   34,   34,   53,   43,   35,   33,
       52,   32,    0,   84,   55,   74,    0,   71,   56,   80,

       82,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   85,   86,   87,   92,   88,
       89,   90,   91,    0,   65,    0,  110,    0,  116,  117,
      114,  115,   38,   38,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    7,    3,    3,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    3,    3,   25,
       26,   22,   24,   23,   56,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   30,   36,   36,   31,   36,   34,
       34,   36,   36,   35,   33,   36,   32,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,  132,
      131,   45,  134,  133,   44,   43,   56,   56,   82,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   86,
       65,  109,  110,  111,  117,  115,    7,    2,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    7,    3,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    3,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,  109,  111,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    7,    3,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    1,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        1,    1,    4,    4,    1,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    4,    1,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        1,    1,    0,    0,    1,    0,    0,    0,    0,    0,
        0,    0,    0,    1,    0,    1,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        3,   36,   36,   36,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    7,    3,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    1,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    1,    4,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    1,    4,    1,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    4,    4,    4,    4,    4,    4,

        4,    4,    1,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    0,    0,    0,    0,    0,
        0,    0,    0,    1,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    3,    7,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    3,
        4,    4,    1,    0,    1,    0,    1,    0,    1,    0,
        0,    0,    0,    0,    0,    1,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    3,    3,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    8,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    1,    1,
        0,    0,    0,    0,    0,    0,    1,    1,    1,    0,
        1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    0,    0,    0,    0,    0,    0,    0,    1,
        0,    1,    0,    0,    1,    0,    0,    0,    0,    0,

        0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    0,    0,    0,    0,    1,    1,    0,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    0,    0,
        0,    0,    1,    1,    1,    1,    1,    1,    0,    0,
        0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    0,    0,    0,    0,    1,    1,
        1,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    1,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,    6,   10,   11,   12,
       13,   14,   15,   16,   17,   18,    1,   19,   20,   21,
       22,   23,   24,   25,   26,   27,   27,    1,    1,    1,
        1,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       54,   55,   56,    6,   57,   58,   59,   60,   61,   62,

       63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
       83,   84,    6,   85,    6,   86,    1,    1,   87,    1,
        1,   88,   89,   90,    1,    1,   91,   92,    1,    1,
       93,    1,   94,   95,   96,   97,    1,    1,   98,    1,
       99,  100,    1,    1,    1,  101,  102,  103,    1,    1,
      104,    1,    1,  105,  106,  107,  108,  109,  110,  111,
        1,    1,  112,  113,  114,  115,  116,  117,  118,  119,
      120,    1,  121,  122,  123,    1,  124,  125,  126,  127,
        1,    1,    1,    1,  128,  129,    1,    1,    1,    1,

        1,  130,    1,  131,    1,    1,    1,  132,  133,    1,
        1,    1,    1,    1,    1,  134,  135,    1,    1,    1,
        1,    1,    1,  136,    1,    1,    1,  137,  138,    1,
      139,    1,    1,    1,  140,  141,    1,    1,  142,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[143] =
    {   0,
        1,    2,    3,    4,    2,    1,    5,    1,    1,    1,
        6,    7,    1,    1,    1,    1,    1,    1,    8,    9,
        9,    9,    9,    8,    8,    8,    8,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,    1,    1,    1,    1,    1,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1
    } ;

static const flex_int16_t yy_base[1791] =
    {   0,
        0,    0,    0,    2,    6,    0,  147,  151,  154,  155,
      235,    0,  377,    0,  153,  516, 6178, 6167,  594,    0,
      736,    0,  878,    0,  158,  167,  162,  175,  177,  178,
        0,    0,  182,  187, 6155, 6144, 6127, 7615, 7615,  207,
     6123, 7615,  519,  526, 1019, 6070, 6061,  192, 6098,    0,
     1072, 1030, 1037, 6111,  515, 7615, 6102, 6083,  203,  525,
     7615, 6100,    0, 7615, 6090,  157,  225, 7615, 6080, 6015,
     6009, 6012,    0, 7615, 6067,    0, 7615, 6063,    0, 7615,
     6062,    0, 1042, 1048, 6056,  537,  217, 6044, 5981,    0,
      554, 6024, 6011, 7615, 5987, 5924, 1060,    0,  549, 5965,

     7615, 5954,  568,  572, 5944,    0, 1126, 1096, 1161, 1177,
      560, 5929, 1105, 7615, 1182, 1193, 1204, 5890, 5881, 5918,
     1258, 1333, 1222, 5927, 5840,  575,  577,    0, 7615, 1032,
        0, 1229, 7615, 1199,  514,  582, 7615, 1052,  522, 5846,
     7615, 7615, 5911,    0, 5901, 5896, 1338, 1060, 1212, 1026,
     1240, 1278, 5899, 1286, 1016, 1365, 1362, 7615, 1050, 7615,
     5812, 1251, 1424, 1024, 1025, 1064, 1091, 1118, 1123, 1138,
     7615,    0, 7615, 5821, 5827, 5817, 1187, 1210, 7615, 5647,
     5652, 5657,    0, 7615,    0, 7615,    0, 7615,    0, 1369,
     1376, 1432, 5717, 1399, 1448, 5718, 1056, 5715, 5662, 1453,

     1457, 1461, 5715, 1233, 7615,    0, 1465, 1509, 5714, 1469,
     5711, 7615, 5708, 5707, 5706, 5705, 1441, 5704,    0, 1282,
     5707, 1443, 1288, 7615, 7615, 5706, 1478, 5705,    0, 1490,
     1496, 5636,  178, 1487, 5634, 1159, 5627, 1482, 1218, 1245,
     1258, 1527, 1558, 1564, 5701, 1569, 1575, 1040, 1106,  170,
     1649, 1724, 1437, 7615, 5700, 1549, 5659, 1582, 5658,  463,
     1478, 1559, 1580, 5628, 1206,    0, 5623, 5626,  511, 1105,
     5624, 1582, 7615, 5675, 1321, 1283,    0, 5673, 1538,    0,
     7615,    0, 5626,  161, 5625, 5600, 5615, 5602, 5610, 7615,
        0,    0, 1588,    0,    0,  989, 5596, 5610, 7615,    0,

     7615, 7615,    0, 7615,    0, 1649, 7615, 1595,    0, 1703,
     1069, 5672, 1605, 5671, 1809, 1884, 5531, 1678, 5533, 5525,
     1047, 5524, 5523, 1595, 1129, 5521, 5536, 1158, 5519, 5534,
     1553, 1596, 1616, 1634, 1677, 1684, 1697, 1710, 1715, 1717,
     1735, 1742, 1743, 5526, 5521, 5517, 5532, 5521, 5519, 1747,
     1762, 1752,    0, 1775, 1769, 5579, 1784, 5576, 5523, 7615,
     1815,    0, 1969, 5576,    0, 1829, 5575,  502,  528,  985,
     1239, 1368, 1948, 1456, 5449, 5530, 5460, 5447, 1512, 5465,
     5482, 5457, 1151, 5457, 5465, 5534,    0, 5531, 5530, 5529,
     5524, 1875, 5523, 5485, 5508, 5481, 5506, 5479, 7615, 5476,

        0, 1751, 1757, 1820, 1841, 1857, 1861, 1863, 1870, 1895,
     1260, 5438, 5453, 1318, 5436, 5451, 5514, 1904, 1912, 1157,
     1923, 1974, 1295, 1199, 1908, 1917, 5513, 1997, 1379, 2020,
     1476, 1429, 2015, 2005, 2040, 1185, 1871, 2121, 1586, 1173,
     1946, 1820, 1309, 2042, 5512, 1930,    0, 2108, 5511, 5510,
     1991, 5500, 2027, 5508, 2076, 2112, 1190, 5507, 5506, 2181,
     2232, 2305, 1499, 2387, 2080, 7615, 1987, 1950, 1999, 2033,
     2042, 2059, 2088, 2094, 2116, 2134, 2135, 2136, 2140, 2141,
     2142, 2174, 2175, 2180, 2184, 2185,    0, 2186, 2190, 2192,
        0, 2194, 1532, 5425, 5440,    0, 2234, 7615, 7615, 2235,

     7615, 7615,    0,    0, 5495, 5449, 5448,    0,    0, 5496,
     5491, 5498, 2240, 1345, 2358, 1482, 1065, 1984, 1501, 1619,
     2357, 5497, 2178, 2245, 5417, 2246, 2251, 2252, 2253, 2284,
     2285, 1653, 5415, 5430, 7615, 5440, 2317, 2318, 2319, 2323,
     2325, 5420, 5425, 5419, 2394, 2327, 5418,    0, 2422, 2427,
     5475,    0, 2390,    0,    0, 2476, 5476,    0, 2444, 1634,
     1707, 2387, 1727, 2413, 1790, 1859, 1865, 1911, 5466, 2347,
     1934, 1264, 1562, 1637, 5345, 5344, 5342, 1481, 5338, 5360,
     5350, 5316, 5352, 5321, 5430,    0, 5427, 5426, 5425, 5424,
     2616, 2756, 5423, 5422, 7615, 7615, 7615, 7615, 7615, 7615,

        0,    0,    0, 2357,    0,    0,    0, 2395, 5370, 2355,
     2389,    0, 5412, 2396, 2454, 2462, 2463, 2468, 2469, 2480,
     2481, 2485, 2486, 2487, 2493, 2494, 2498, 2504, 2505, 2506,
     2516, 2520, 2522, 2524,    0, 2526, 2528, 2530,    0, 2532,
        0,    0,    0, 5365, 1757, 5364, 5339, 5354, 5341, 5349,
        0,    0, 2534,  190, 1968, 5335, 5350,    0, 2870,    0,
        0, 2896,    0, 1628, 2527,    0, 2553, 1778, 7615,    0,
        0,    0, 2536, 2554, 2555, 2560, 2561,    0,    0, 2565,
     2566,    0, 2567, 2571, 2572, 2573,    0,    0, 2577, 2578,
        0, 2579, 5360, 2583, 2584, 7615, 5359, 7615, 2585, 7615,

        0, 2590, 5332, 2591, 2592, 2596, 2597, 2598, 2604, 2001,
     5330, 5345, 2041, 5328, 5343, 2620, 2622, 2624, 2626, 2628,
     2630, 2632, 2634, 5353, 7615, 5349, 2636, 5337, 2638, 2644,
     2645, 2646, 2662, 2670,    0, 2674, 2653, 5403, 1956, 2682,
     1954, 5393, 1827, 2011, 2049, 2660, 2054, 2632, 2691, 2171,
     2702, 2431, 5393, 2607, 2641, 2639, 5363, 5287, 5310, 5292,
     1283, 1552, 1726, 5302, 5264, 5278, 5249, 2707, 5247, 5242,
     5242, 5376,    0,    0,    0,    0, 2979, 2740, 2658, 2658,
     2657, 2658, 2670, 2758, 2680, 5252, 1154, 5332, 5261, 5248,
     2624, 5239, 5256, 5232, 2380, 5233, 5237, 2962, 2679, 2683,

     2678, 2682, 2703, 2995, 2708, 5210, 1366, 5291, 5221, 5208,
     2640, 5226, 5243, 5217, 2406, 5218, 5226,    0,    0,    0,
        0,    0,    0,    0, 2768, 2590, 5244, 5259, 2645, 5242,
     5257,    0, 2769,    0,    0,    0,    0, 2777, 2786, 2796,
     2800, 2807,    0,    0, 2813, 2814,    0, 2822, 2824, 2828,
     2830,    0,    0, 2834, 2836,    0, 2838,    0,    0, 2842,
        0,    0,    0, 1850, 5267, 3096, 3122, 1690, 1901,    0,
        0,    0,    0,    0,    0,    0, 2846, 2847,    0, 2848,
     2852, 2853, 2854, 2858, 2859, 2860, 2865,    0, 5266, 2877,
     7615, 2948, 2949, 2983, 2987, 2991,    0, 2992, 2753, 2800,

     5309, 2938, 2973, 2959, 3008, 2982, 2989, 2993, 5226, 5203,
     5186, 2605, 5183, 5180, 5190, 5177, 5197, 2745, 2036, 2930,
     5186, 5186, 5199, 5300,    0,    0, 3205, 3188, 2994, 2996,
     2990, 2993, 3004, 3221, 3012, 5176, 1578, 5246, 5175, 5161,
     2951, 5179, 5196, 5171, 2952, 5171, 5178, 3213, 2989, 3012,
     3049, 3016, 3222, 3021, 3036, 3038, 3045, 5267, 2995, 3038,
     2450, 3338, 3288, 2264, 2927, 5145, 5144, 5143, 1568, 5138,
     5154, 5170, 5133, 5165, 5132, 3249, 3037, 3148, 3204, 3172,
     3364, 3178, 3190, 3199, 3207, 5238, 3186, 3215, 2968, 5235,
     3405, 2391, 2945, 5114, 5113, 5110, 3079, 5104, 5094, 5110,

     5075, 5108, 5074,    0, 3067, 5133, 3087,    0,    0,    0,
        0,    0,    0,    0, 3174,    0,    0, 3217,    0, 3235,
     3221,    0, 3277, 3281,    0, 3236, 3349, 3253, 3255, 3250,
     3289, 3360, 5057, 1422, 5084, 3294, 5063, 5034, 5078, 5075,
     5052, 3183, 5064, 5027, 5025, 5032, 5024, 5046, 5128,    0,
        0, 3447, 3430, 3371, 3371, 3365, 3366, 3375, 3463, 3380,
     5004, 3267, 5084, 5013, 4972, 3309, 4990, 5007, 4977, 3252,
     4976, 4981, 3438, 3357, 3415, 3449, 3414, 3468, 3412, 3429,
     3432, 3439, 5070, 3428, 3433, 3246, 3580, 3619, 2614, 3257,
     4949, 4946, 4944, 3200, 4941, 4961, 4952, 4917, 4952, 4918,

     3455, 3296, 3337, 3457, 3538, 3457, 5021, 3309, 3464, 3476,
     3619, 3482, 3505, 3544, 3489, 3647, 3512, 5018, 3500, 3530,
     3522, 3693, 3628, 3692, 3742, 4986, 4909, 4931, 4913, 2602,
     2703, 1953, 4930, 4893, 4900, 4871, 3555, 4869, 4862, 4862,
     3526, 3416, 3503, 3541, 3648, 3533, 4965, 3355, 3564, 3595,
     3733, 3618, 3717, 3694, 3625, 3770, 3635, 4963, 3620, 3646,
     3636,    0, 3779, 3828, 3857, 4933, 4857, 4879, 4823, 2709,
     3164, 2007, 4842, 4805, 4819, 4789, 3679, 4784, 4775, 4772,
        0, 3451, 3593, 3683,    0, 3715, 3714, 3265, 3833, 3837,
     4753, 4745, 4742, 4757, 4737, 4756, 3854, 3858, 3862, 4729,

     3885, 4861, 4857, 4824, 3997, 3927, 3749, 3741, 3861, 3862,
     3769, 3899, 3786, 2597, 3865, 2608, 2663, 3543, 3885, 2090,
     2024, 1828, 3656, 2757, 2993, 3916, 3747, 3781, 3896, 3868,
     4001, 3877, 3898, 3909, 3936, 3456, 3918, 3930, 3699, 3783,
     4067, 3467, 3690, 1234, 2945, 3348, 3888, 1657, 3780, 2447,
     3583, 2199, 3405, 3943, 4009, 3954, 3958, 4040, 3974, 3932,
     3929, 3970, 3977, 4071, 4025, 4069, 4068, 3863, 4113, 4048,
     2235, 4064, 4093, 4042, 4823, 4134, 4171, 4175, 3787, 3989,
     1968, 3225, 3976, 4099, 4012, 2801, 3889, 3799, 1788, 4142,
     2635, 2067, 3457, 4149, 4101, 4212, 4117, 4115, 3651, 4160,

     4151, 4176, 4218, 4219, 4221, 4236, 4234, 4062, 2999, 3665,
     4044, 2384, 4028, 3814, 2988, 3680, 3817, 3996, 4109, 4159,
     4178, 4089, 4046, 3500, 4197, 4237, 4302, 3886, 4067, 4808,
     4165, 4230, 4215, 4290, 4230, 4245, 4252, 4807, 4735, 4746,
     4711, 4655, 4633, 4032, 4606, 4603, 4587, 4574, 4568, 4067,
     3945, 4099, 4556, 4546, 4541, 4628, 7615, 4258, 4265, 4511,
     4518, 4236, 4160, 4490, 4464, 4484, 4335, 4339, 4344, 4352,
     4361, 4365, 4369, 4373, 4377, 4381, 4492, 4575,    0,    0,
     7615, 4359, 4274,    0, 4387, 4396, 4396, 4273, 4402, 4288,
     4327, 4311, 4357, 4410, 4564, 4403, 4434, 4180, 4459, 4339,

     4430, 4398, 4432, 4408, 4384, 4303, 4393, 4246, 4236, 4245,
     4223, 4224,    0,    0, 4349, 4373, 4443, 4173, 4170, 4085,
     4052, 4091, 4058, 4450, 4460, 4464, 4053, 4120, 4463, 4025,
     4034, 4405, 4400, 4482, 4482,    0, 4498, 4317, 4475, 4526,
     3947, 3874, 3839, 3842, 3745, 3764, 4535, 4541, 4545, 3685,
     4549, 4402, 4428, 2310, 2320, 4198, 3658, 4547, 3636, 4440,
     4453, 4563, 3455, 3441, 4460, 4163, 3391, 3366, 3329, 4586,
     4587, 4596, 4600, 4619, 4638, 4642, 4651, 4652, 4658, 4659,
     4665, 4666, 3232, 4479, 4478, 4673, 4512, 3189, 4665, 4471,
        0, 4556, 4530, 4539, 4693, 3142, 3046, 2974, 2760, 2804,

     2763, 4697, 4804, 4734, 4710, 4858, 4773, 4717, 4912, 4964,
     2773, 4493, 4526, 4711, 4565, 4587, 3585, 4362, 4581, 2733,
     5018, 4762, 4973, 4766, 5072, 4774, 5124, 4813, 5178, 4867,
     5133, 4913, 2682, 2623, 4597, 4604, 5029, 4921, 2481, 4762,
     5179, 5185, 4989, 5189, 5193, 4993, 5197, 5230, 4603, 4591,
     4609, 4624, 5276, 5320, 5372, 5416, 5468, 5512, 2337, 2311,
     2068, 1849, 5564, 5025, 5592, 5033, 5591, 5037, 5619, 5084,
     5671, 5234, 5699, 5253, 4607, 4611, 4640, 4639, 5073, 5150,
     5154, 4742, 1717, 1681, 1629, 4692, 4688, 4705, 1614, 5262,
     1549, 4675, 4708, 1505, 1464, 4691, 4756, 1346, 1266, 4763,

     4762, 4934, 1081, 4884, 5266, 7615, 5752, 5763, 5774, 5785,
     5796, 5807, 5818, 5829, 5840, 5851, 5862, 5866, 5877, 5888,
     5899, 5910, 5921, 5932, 5943, 5954, 5965, 5976, 5987, 5998,
     6002, 6013, 6024, 6035, 6046, 6051, 6052, 6057, 6068, 6079,
     6090, 6101, 6112, 6123, 6134, 6145, 6156, 6167, 6178, 6189,
     6200, 1092, 6211, 6222, 6233, 6244, 6255, 6266, 6277, 6288,
     1028, 6290, 6301, 6312, 6323, 6334, 6345, 6356, 6367, 6378,
     6389, 6400, 6411, 6422, 6433, 6444, 6455, 6466, 6477, 6488,
     6499, 6510,  556, 6512, 6523, 6534, 6545, 6556, 6567, 6578,
     6589, 6600, 6611, 6622, 6633, 6644, 6655, 6666, 6677, 6688,

     6699, 6710, 6721, 6732, 6743, 6754, 6765, 6776, 6787, 6798,
     6809, 6820, 6831, 6842, 6853, 6864, 6875, 6886, 6897, 6908,
     6919, 6930, 6941, 6952, 6963, 6974, 6985, 6996, 7007, 7018,
     7029, 7040, 7051, 7062, 7073, 7084, 7095, 7106, 7117, 7128,
     7139, 7150, 7161, 7172, 7183, 7194, 7205, 7216, 7227, 7238,
     7249, 7260, 7271, 7282, 7293, 7304, 7315, 7326, 7337, 7342,
     7352, 7363, 7374, 7385, 7396, 7407, 7418, 7429, 7440, 7451,
     7462, 7473,  544, 7484, 7495, 7506, 7517, 7528, 7539, 7546,
     7552, 7562,  218, 7567,  216, 7577, 7588, 7599, 7604,  189
    } ;

static const flex_int16_t yy_def[1791] =
    {   0,
     1607, 1607, 1608, 1608, 1606,    5,    5,    5, 1609, 1609,
     1606,   11, 1606,   13, 1610, 1610, 1611, 1611, 1606,   19,
     1606,   21, 1606,   23, 1612, 1612, 1613, 1613, 1614, 1614,
     1607, 1607, 1615, 1615, 1616, 1616, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1617, 1606, 1606, 1606, 1606, 1606, 1618,
     1606, 1606, 1617, 1606,   51, 1606, 1606, 1606, 1619, 1606,
     1606, 1606, 1620, 1606, 1606, 1606, 1621, 1606, 1606, 1606,
     1606, 1606, 1622, 1606, 1606, 1623, 1606, 1606, 1624, 1606,
     1606, 1625, 1606, 1617, 1606, 1606, 1606, 1606, 1606, 1626,
     1606, 1626, 1626, 1606, 1606, 1606, 1627, 1628, 1606, 1628,

     1606, 1606, 1606, 1606, 1606, 1629, 1629, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1630, 1606, 1606, 1606, 1606,
     1606, 1606, 1617, 1606, 1606, 1606, 1606, 1631, 1606, 1606,
     1632, 1606, 1606, 1633, 1634, 1606, 1606, 1606, 1635, 1606,
     1606, 1606, 1636, 1637, 1638, 1606, 1606, 1606, 1606, 1606,
     1606, 1630, 1606,  121,  122, 1617, 1633, 1606, 1635, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1639, 1606, 1606, 1606, 1606, 1640, 1606, 1606, 1606,
     1606, 1606, 1641, 1606, 1642, 1606, 1643, 1606, 1644, 1606,
     1606, 1606, 1606, 1606, 1645, 1606, 1606, 1606, 1606, 1617,

     1606, 1606, 1606, 1606, 1606, 1646, 1606, 1606, 1606, 1606,
     1646, 1606, 1606, 1647, 1648, 1647, 1648, 1647, 1649, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1650, 1650,
     1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1606, 1606,
     1606, 1606, 1651, 1606, 1651, 1651, 1651, 1651, 1651, 1651,
     1651, 1651, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1652, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1653, 1606, 1606, 1654, 1606, 1606, 1655,
     1606, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1606,
     1657, 1658, 1606, 1659, 1660, 1660, 1660, 1660, 1606, 1661,

     1606, 1606, 1662, 1606, 1663, 1606, 1606, 1606, 1664, 1606,
     1651, 1606, 1651, 1651, 1651, 1651, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1656, 1656, 1656, 1660, 1660, 1660,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1665, 1665, 1666, 1665, 1665, 1665, 1665, 1606,
     1606, 1667, 1606, 1606,  363,  363, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1667, 1668, 1669, 1669, 1670,
     1670, 1670, 1671, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1672, 1673, 1673, 1673, 1673, 1673, 1673, 1673, 1673, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1651, 1651, 1651, 1651,
     1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1651, 1651, 1651, 1651, 1651, 1651, 1674, 1651, 1651, 1651,
     1675, 1676, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1651,  461, 1651, 1651, 1651, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1677, 1606, 1606, 1606,
     1678, 1606, 1606, 1606, 1606, 1679, 1606, 1606, 1606, 1606,

     1606, 1606, 1680, 1681, 1682, 1606, 1606, 1683, 1684, 1685,
     1686, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1687, 1651, 1651, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1689, 1606, 1606,  556, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1689, 1690, 1691, 1691, 1692, 1692,
     1692, 1606, 1693, 1693, 1606, 1606, 1606, 1606, 1606, 1606,

     1694, 1695, 1696, 1697, 1698, 1699, 1700, 1606, 1606, 1701,
     1701, 1702, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701,
     1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701,
     1701, 1701, 1701, 1701, 1703, 1701, 1701, 1701, 1704, 1701,
     1705, 1701, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1701, 1707, 1701, 1708, 1701, 1701, 1701, 1701, 1701, 1701,
     1701, 1701, 1701, 1709, 1701, 1701, 1701, 1710, 1606, 1711,
     1712, 1713, 1606, 1606, 1606, 1606, 1606, 1714, 1715, 1606,
     1606, 1716, 1606, 1606, 1606, 1606, 1717, 1718, 1606, 1606,
     1719, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1720, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1721,
     1721, 1721, 1701, 1701, 1701, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1722, 1722, 1723, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1723, 1724, 1725, 1726, 1727, 1726, 1727, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1728, 1729, 1730,
     1731, 1732, 1733, 1734, 1606, 1701, 1701, 1701, 1701, 1701,
     1701, 1735, 1701, 1701, 1736, 1737, 1738, 1701, 1701, 1701,
     1701, 1701, 1739, 1740, 1701, 1701, 1741, 1701, 1701, 1701,
     1701, 1742, 1743, 1701, 1701, 1744, 1701, 1701, 1701, 1701,
     1701, 1701, 1745, 1746, 1701, 1701, 1701, 1747, 1748, 1749,
     1750, 1751, 1752, 1753, 1754, 1755, 1606, 1606, 1756, 1701,
     1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1757, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1757, 1758, 1759, 1759, 1759, 1759, 1759,
     1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759,
     1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759,
     1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759,
     1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759,
     1759, 1759, 1759, 1759, 1759, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1760,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1761, 1701, 1701, 1701, 1762, 1763, 1764,
     1765, 1766, 1767, 1768, 1701, 1701, 1701, 1701, 1701, 1769,
     1701, 1701, 1606, 1606, 1770, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1770, 1771,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,

     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772, 1772,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1773, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1774, 1701, 1701, 1769, 1775, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1776, 1777, 1778, 1606,

     1606, 1775, 1779, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1780,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1773, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1781, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1780, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1781, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1307, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1782, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1777, 1776, 1776, 1776,
     1777, 1777, 1777, 1778, 1778, 1778, 1606, 1606, 1779, 1779,
     1606, 1606, 1606, 1783, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1784, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1782, 1782, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1776, 1777, 1778, 1606, 1606, 1781, 1606,
     1606, 1606, 1606, 1606, 1606, 1785, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1786, 1787, 1788, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1789, 1606,
     1606, 1784, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1787,
     1786, 1786, 1786, 1786, 1787, 1787, 1787, 1787, 1788, 1788,
     1788, 1788, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1790, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1786, 1786, 1786, 1787, 1787, 1787, 1788, 1788, 1788,
     1606, 1606, 1606, 1789, 1606, 1606, 1606, 1606, 1606, 1606,
     1786, 1786, 1786, 1786, 1787, 1787, 1787, 1787, 1788, 1788,
     1788, 1788, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1503,
     1786, 1786, 1506, 1787, 1787, 1509, 1788, 1788, 1606, 1606,
     1606, 1606, 1786, 1503, 1787, 1506, 1788, 1509, 1606, 1606,
     1606, 1606, 1786, 1786, 1521, 1786, 1787, 1787, 1525, 1787,
     1788, 1788, 1529, 1788, 1606, 1606, 1606, 1606, 1554, 1556,
     1558, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606,    0, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606
    } ;

static const flex_int16_t yy_nxt[7758] =
    {   0,
     1606, 1606,   40,   41,   40,   41,   42,   43,   44,   45,
       43,   42,   42,   42,   42,   42,   46,   47,   42,   42,
       42,   48,   49,   46,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   42,
       51,   42,   42,   42,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   52,   53,
       54,   52,   52,   53,   54,   52,   69,   57,   57,   83,
       84,   85,   83,   42,   91,   92,   93,   42,   83,   84,
       85,   83, 1606,   86,   87,   58,   58,   91,   92,   93,
       95,   95,   86,   87,   99,  100,  425,   96,   96,   99,
      100,   70,  505,  126,   97,   97,  126,   71, 1514,   72,

      417,   55,   59,   59,  163,   55,  402,  163,  103,  104,
      105,  103,   88,  402,   89,  174,  175,  106,  176,  202,
      203,   88,   70,   89,  107, 1462,  178, 1429,   71,  178,
       72,  500,  500,   60,   60,   61,   61,   61,   62,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   61,   61,
       61,   61,   61,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   64,   64,   64,
       65,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   66,   64,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       64,   64,   64,   64,   64,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,

       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   69,
      109,  110,  110,  109,  474,  291,  157,  115,  116,  117,
      115,  158,  559,  475,  111,  112,  118,  119,  201,  201,
      201,  201,  120,  121,  164,  165,  166,  167,  168,  169,
      170,  220,  221, 1338,   70,  207,  208,  209,  207,  560,
       71,  126,   72,  559,  126,  301,  222,  292,  159,  103,
      225,  226,  103,  113,  227,  228,  126,  487,  279,  126,
      122,  279,  106,  279,  296,   70,  279,  297,  488,  107,
      560,   71,  298,   72,   74,   74,   74,   75,   74,   74,

       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   74,   74,   74,
       74,   74,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,

       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   77,   77,   77,   78,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   77,
       77,   77,   77,   77,   79,   79,   79,   79,   79,   79,

       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   80,   80,
       80,   81,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   82,   82,   82,   82,

       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   80,   80,   80,   80,   80,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
      110,  123,  110,  110,  561,  337,  338,  157,  337,  338,
      130,  149,  158,  130,  149,  112,  130,  508,  151,  152,
      153,  151, 1606,  190,  130,  111,  190,  118,  119,  194,
      195,  196,  194,  293,  154,  561,  293,  191,  192,  507,
      507,  308,  294,  215,  308,  339,  216, 1606,  339,  324,
      309,  311,  512,  112,  129,  129,  130,  129,  131,  131,
      132,  129,  133,  134,  150,  135,  150,  360,  136,  137,
      130,  155,  340,  197,  423,  340,  193,  103,  104,  105,

      103,  484,  198,  130,  199,  217,  106,  360, 1606,  130,
      138,  130,  328,  107,  218,  329,  240,  475,  360,  341,
      330,  239,  341,  130,  342,  139,  140,  342,  529,  141,
      129,  138,  129,  129,  142,  143,  217,  138,  360,  343,
      144,  138,  343,  145,  146,  129,  706,  129,  147,  130,
      129,  138,  148,  138,  230,  129,  129,  130,  241, 1606,
      424,  231,  109,  110,  110,  109,  232,  489,  489,  490,
      233,  234,  235,  425,  236, 1606,  111,  112,  110,  110,
      110,  110,  130,  242,  243,  244,  242, 1606,  178,  237,
      130,  178, 1606,  112,  246,  116,  247,  246,  112,  535,

      535, 1606,  238,  248,  249,  110,  116,  110,  110,  250,
      251,  178, 1604,  149,  178,  113,  149,  962,  408,  410,
      112,  408,  410,  115,  116,  117,  115,  111,  536,  536,
      963,  112,  118,  119,  204,  634,  113,  204,  120,  121,
     1381,  310,  311,  312,  310,  581,  582,  252,  281,  281,
      281,  281,  281,  281,  281,  281,  630,  283,  112,  253,
      254,  284,  253,  285,  286,  483,  150,  658,  483,  287,
      332,  333,  334,  335,  288,  255,  122,  289,  562,  313,
      152,  314,  313,  613,  220,  221,  256,  193,  248,  249,
      220,  221,  257,  258,  150,  315,  259, 1606,  260,  222,

      261,  612,  262,  263,  264,  222,  265,  411,  266,  562,
      412, 1606,  124,  317,  318,  413,  319,  267,  320,  268,
      414,  269,  410,  415,  270,  410,  321,  322,  416,  271,
      608,  608,  316,  323,  272,  129,  129,  130,  129,  131,
      131,  132,  273,  133,  134,  493,  274, 1606,  494,  275,
      137,  130,  306,  495,  306,  756,  307,  307,  307,  307,
      307,  307,  307,  307,  307, 1170,  151,  152,  153,  151,
      190,  138,  639,  190,  756,  118,  119,  201,  201,  201,
      201, 1606,  154,  911,  191,  192,  276,  140,  609,  609,
      141,  129,  138,  129,  129,  142,  143, 1601,  138,  563,

      352,  144,  138,  352,  145,  146,  129,  911,  129,  147,
      130,  129,  138,  148,  138,  192,  129,  129,  130,  155,
      283,  617,  702,  193,  325,  336,  285,  326,  336,  990,
      563, 1606,  327,  350,  350,  350,  350,  288,  253,  254,
      289,  253,  991,  332,  333,  334,  335,  391,  351,  354,
      355,  356,  354,  193,  194,  195,  196,  194,  201,  201,
      201,  201,  361,  361,  361,  361,  207,  363,  364,  207,
      207,  208,  209,  207,  394,  392,  395, 1600, 1606,  476,
      227,  228,  476,  571, 1606,  396,  392,  397,  106,  398,
      622,  401,  392,  357,  401,  107,  399,  401,  197,  623,

      401, 1606,  358, 1606,  359,  664,  392,  198,  477,  199,
      365,  366,  367,  365,  571,  402,  406,  392,  621, 1189,
      478,  406,  400,  392,  403,  402,  402,  406,  242,  243,
      244,  242,  406,  406,  402, 1190,  368,  369,  406,  279,
      403, 1189,  279,  112,  370,  371,  404,  406,  372,  373,
      467,  374,  406,  467,  537,  375,  705,  537,  406,  418,
      243,  419,  418,  406,  406,  110,  243,  110,  110,  406,
      421,  110,  418,  421,  420,  376,  418,  116,  418,  418,
      112,  113,  708,  467,  468,  420,  467,  468, 1606,  293,
      479,  420,  293,  468,  468, 1597,  308,  538,  294,  308,

      538,  575,  693,  693,  480,  309,  446, 1606,  468,  446,
      470,  576,  420,  577,  481,  764,  481,  539,  112,  468,
      539, 1606,  765,  422,  471,  481,  470,  481,  757,  420,
      510,  481,  472,  481,  417,  540, 1596,  377,  540,  378,
      379, 1087,  380,  381,  382,  481,  383,  481,  384,  385,
      426,  254,  912,  426, 1088,  492,  481,  532,  481,  513,
      533,  633,  481, 1381,  481,  534,  427,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  912,  428,  541,  467,
     1593,  541,  467,  429,  430,  336,  739,  431,  336,  432,
      758,  433,  510,  434,  435,  436, 1019,  437,  337,  438,

      709,  337, 1133,  423,  310,  311,  312,  310,  439, 1134,
      440,  338,  441,  468,  338,  442,  339,  739,  340,  339,
      443,  340,  468,  724,  724,  444,  129,  445,  446,  445,
      447,  447,  448,  449,  450,  451,  341,  452,  740,  341,
      453,  454,  446,  342,  343, 1592,  342,  343,  350,  350,
      350,  350,  401,  352,  525,  401,  352,  150,  401,  526,
     1588,  401,  455,  350,  350,  350,  350,  744,  192,  740,
      354,  355,  356,  354,  759,  760,  549,  456,  457,  549,
      511,  458,  445,  455,  445,  445,  459,  460,  417,  455,
     1175,  550,  461,  455, 1381,  462,  463,  445,  744,  445,

      464,  446,  445,  455,  465,  455,  193,  445,  445,  446,
      426,  254, 1587,  426,  357,  552,  361,  361,  361,  361,
      913,  602, 1606,  358,  602,  359,  427,  860,  860,  551,
      558,  366,  367,  558, 1381,  552,  514,  515,  749,  516,
      913,  517,  603,  429,  430,  603,  552,  431, 1586,  518,
      519,  433,  505,  434,  435,  436,  520,  437,  604,  438,
     1017,  604,  605,  423,  606,  605,  552,  606,  439,  749,
      440,  607,  441, 1606,  607,  442,  591,  592,  591,  591,
      443,  590,  637,  637,  638,  444,  129,  445,  446,  445,
      447,  447,  448,  449,  450,  521,  410,  452,  750,  410,

      522,  454,  446,  511,  751,  418,  110,  418,  418,  614,
     1606, 1020,  614,  418,  243,  418,  418,  741,  426,  254,
      420,  426,  455, 1349,  421,  110,  418,  421,  420,  750,
      631,  446, 1606,  631,  446,  751,  741,  523,  457,  420,
      999,  458,  445,  455,  445,  445,  459,  460, 1606,  455,
      752,  467,  461,  455,  467,  462,  463,  445,  420,  445,
      464,  446,  445,  455,  465,  455,  420,  445,  445,  446,
      365,  556,  557,  365, 1381,  564, 1606,  422,  446,  565,
     1578,  752,  755,  566,  513,  610, 1606,  899,  467,  567,
      425,  467,  446,  669,  900,  568,  368,  369,  615, 1606,

      670,  615,  569,  670,  370,  371,  564, 1606,  372,  373,
      565,  374,  635,  755,  566,  375,  624, 1606,  899,  624,
      567,  615, 1606,  636,  615,  900,  568,  611,  614, 1606,
     1381,  614,  616,  616,  467,  376,  627,  467,  865,  865,
      616,  616, 1606,  671, 1606,  625,  671, 1314,  618,  644,
      628,  446,  749,  645,  623,  646,  647,  626, 1341,  446,
      672,  648,  619,  672,  618,  707,  649, 1314,  616,  650,
      620,  888,  888, 1381,  629,  570,  629,  653, 1606,  616,
      653,  667, 1606,  749,  667,  629,  654,  629,  749,  673,
      668,  629,  673,  629,  749,  674, 1381,  377,  674,  378,

      379, 1345,  380,  381,  382,  629,  383,  629,  384,  385,
     1606,  889,  889,  998, 1606,  640,  629,  675,  629,  749,
      675, 1345,  629, 1606,  629,  749,  909,  642,  642,  642,
      642,  642,  642,  642,  642,  476,  676,  677,  476,  676,
      677,  678,  679,  680,  678,  679,  680, 1043,  632,  632,
      632,  632,  632,  632,  632,  632,  632,  632,  632,  632,
      632,  632,  632,  632,  632,  632,  632,  632,  632,  632,
      632,  632,  632,  632,  655,  681,  682,  656,  681,  682,
     1606,  683,  657, 1606,  683,  684,  685,  688,  684,  685,
      688,  689,  659,  690,  689,  692,  690,  997,  692, 1577,

      660,  660,  660,  660,  686, 1381,  749, 1354,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660, 1606,  694,  695,  749,  694,  695,
      713, 1381, 1606,  714,  446, 1335,  716,  718,  715,  716,
      718,  686,  719,  720,  721,  719,  720,  721,  446,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  722,  723, 1179,  722,  723,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,

      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  662,  446,  537,  538,
      539,  537,  538,  539,  540,  446,  541,  540,  731,  541,
     1126,  731,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  604,  615,
     1606,  604,  615,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663, 1606,
     1381,  553, 1127,  616,  553,  729,  695,  614,  729,  695,

      614,  665,  616,  665, 1486,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  730,  644, 1487,  826,  741,  710,
      827,  646,  711,  549, 1486,  828,  549,  712,  733,  350,
      733,  733,  649,  754,  703,  650, 1487,  565,  550,  704,
      745,  742, 1576,  734,  551,  736,  737,  738,  736,  741,
      754,  829,  746, 1381,  830,  615,  565, 1166,  615,  831,
      834,  747,  749,  615,  835,  748,  615,  835, 1575,  615,
      836,  745,  615,  836,  972,  973,  551,  558,  556,  557,
      558,  837,  838,  746,  837,  838,  839,  840,  624,  839,
      840,  624,  747,  749,  841,  842,  748,  841,  842,  843,

     1000, 1001,  843,  368,  369,  844,  845,  846,  844,  845,
      846,  370,  371, 1397,  743,  372,  373,  847,  374, 1167,
      847,  848,  375,  849,  848,  850,  849,  853,  850,  854,
      853,  855,  854,  857,  855,  653,  857,  673,  653, 1177,
      673, 1121,  376,  851,  654,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  667,  674,  675,  667,  674,  675,
     1121,  676,  677,  668,  676,  677,  680,  681,  683,  680,
      681,  683,  684,  685,  685,  684,  685,  685,  689,  690,
      692,  689,  690,  692,  694,  695,  878,  694,  695,  878,
      851,  880,  882,  883,  880,  882,  883,  884,  885,  886,

      884,  885,  886, 1381,  377,  887,  378,  379,  887,  380,
      381,  382, 1552,  383, 1381,  384,  385,  777,  592,  777,
      777,  716,  778,  890,  716,  718,  890,  719,  718,  720,
      719,  721,  720,  722,  721,  723,  722,  893,  723,  729,
      893, 1381,  729,  779,  780,  895,  731,  896,  895,  731,
      896,  781,  782,  992,  898,  783,  784,  898,  785,  907,
     1005, 1005,  786,  733,  350,  733,  733,  902,  908, 1381,
      787,  733,  350,  733,  733,  736,  737,  738,  736,  749,
     1279,  903,  788,  736,  737,  738,  736,  749,  948,  949,
      907,  749,  736,  737,  738,  736,  950,  951,  902,  908,

      749,  952, 1312,  736,  737,  738,  736,  960,  918,  976,
      749,  918,  903,  966,  977, 1006, 1006,  978,  749,  948,
      949,  979,  749,  967,  989,  968, 1312,  950,  951,  994,
      904,  749,  952,  905,  980,  988, 1034, 1035,  960,  995,
      976,  996, 1280,  749,  789,  977,  790,  791,  978,  792,
      793,  794,  979,  795, 1550,  796,  797,  592,  592,  592,
      592,  904,  798, 1381,  905,  980,  988,  779,  780,  878,
     1007, 1353,  878, 1007,  749,  781,  782,  808,  838,  783,
      784,  838,  785,  799,  800,  953,  786,  839, 1026,  954,
      839,  801,  802,  955,  787,  803,  804,  840,  805,  956,

      840,  841,  806, 1313,  841,  957,  788, 1381,  842, 1343,
      807,  842,  958, 1549,  845,  846,  953,  845,  846, 1026,
      954, 1154,  808,  848,  955,  849,  848, 1313,  849,  850,
      956,  850,  850, 1343,  850,  854,  957,  855,  854,  857,
      855, 1027,  857, 1015,  919,  920, 1015,  878,  878,  880,
      878,  878,  880, 1021,  882,  883, 1021,  882,  883,  884,
      885,  886,  884,  885,  886, 1449,  887, 1002,  789,  887,
      790,  791, 1027,  792,  793,  794, 1154,  795,  890,  796,
      797,  890, 1041, 1042,  809,  959,  810,  811, 1346,  812,
      813,  814, 1154,  815, 1520,  816,  817,  866,  866,  866,

      866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
      866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
      866,  866,  866,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867, 1023,
      893, 1381, 1023,  893,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      927,  592,  927,  927, 1024,  928,  740, 1024,  895,  799,
      800,  895,  896,  898, 1381,  896,  898,  801,  802, 1381,

      749,  803,  804, 1029,  805, 1381,  929,  930,  806,  736,
      737,  738,  736,  565,  931,  932,  807,  740,  933,  934,
     1030,  935,  981, 1031, 1073,  936,  982, 1074,  808, 1075,
      983,  749, 1076,  937, 1029, 1077,  984, 1044, 1045, 1085,
     1091, 1104,  985, 1105,  565,  938, 1097, 1098,  749,  986,
     1092, 1030, 1093,  981, 1031, 1073, 1109,  982, 1074, 1161,
     1075,  983, 1395, 1076, 1128, 1129, 1077,  984, 1015, 1114,
     1085, 1015, 1104,  985, 1105, 1115, 1171, 1116, 1161,  749,
     1106, 1119, 1168, 1169, 1117, 1079, 1120, 1109, 1007, 1144,
      809, 1007,  810,  811, 1003,  812,  813,  814, 1119,  815,

     1114,  816,  817, 1107, 1079, 1519, 1115,  939, 1116,  940,
      941, 1106,  942,  943,  944, 1117,  945, 1120,  946,  947,
     1144, 1401,  987,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663, 1015, 1108, 1518, 1015, 1145,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  663,  663,  663,

      663,  663,  663,  663,  663,  663, 1052,  592, 1052, 1052,
     1145, 1053, 1149, 1173, 1101, 1054, 1055, 1101, 1183, 1102,
     1174, 1183, 1021, 1056, 1057, 1021, 1154, 1058, 1059, 1155,
     1060, 1381, 1054, 1055, 1061, 1146,  417,  879, 1156,  417,
     1056, 1057, 1062, 1149, 1058, 1059, 1157, 1060, 1078, 1110,
     1141, 1061, 1079, 1141, 1063, 1142, 1080, 1154, 1147, 1062,
     1155, 1111, 1081, 1160, 1344, 1186, 1146, 1103, 1082, 1156,
     1112, 1063, 1159, 1517, 1113, 1083,  982, 1157, 1023, 1078,
     1110, 1023, 1024, 1079,  741, 1024,  749, 1080, 1344, 1159,
     1196, 1045, 1111, 1081, 1160,  982, 1186, 1294, 1027, 1082,

     1294, 1112, 1124, 1143, 1124, 1113, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125,  741, 1064,  749, 1065, 1066,
     1513, 1067, 1068, 1069, 1187, 1070, 1511, 1071, 1072, 1027,
     1240, 1148, 1342, 1064, 1286, 1065, 1066, 1274, 1067, 1068,
     1069, 1287, 1070, 1241, 1071, 1072, 1250, 1251, 1084, 1122,
      736,  737,  738,  736, 1381, 1187, 1274, 1123, 1123, 1123,
     1123,  736,  737,  738,  736, 1123, 1123, 1123, 1123, 1123,
     1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123,
     1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123,
     1123, 1150, 1191, 1192, 1281, 1282, 1360, 1361, 1244, 1259,

     1295, 1226, 1227, 1151, 1228, 1229, 1230, 1238, 1245, 1257,
     1246, 1381, 1152, 1296, 1191, 1192, 1153, 1325, 1259, 1164,
     1325, 1164, 1150, 1165, 1165, 1165, 1165, 1165, 1165, 1165,
     1165, 1165, 1226, 1227, 1151, 1228, 1229, 1230, 1238, 1254,
     1257, 1501, 1254, 1152, 1255, 1146, 1258, 1153, 1205,  592,
     1205, 1205, 1183, 1206, 1262, 1183, 1254, 1207, 1208, 1254,
     1267, 1255, 1381, 1381, 1146, 1209, 1210, 1158, 1268, 1211,
     1212, 1269, 1213, 1381, 1207, 1208, 1214, 1258, 1270, 1172,
     1259, 1273, 1209, 1210, 1215, 1262, 1211, 1212, 1297, 1213,
     1231, 1267, 1256, 1214, 1232, 1263, 1216, 1298, 1233, 1268,

     1500, 1215, 1269, 1260, 1234, 1267, 1381, 1264, 1499, 1270,
     1235, 1259, 1273, 1216, 1272, 1267, 1265, 1236, 1232, 1297,
     1266, 1231, 1267, 1180, 1267, 1232, 1263, 1141, 1298, 1233,
     1141, 1272, 1142, 1166, 1495, 1234, 1267, 1232, 1264, 1254,
     1300, 1235, 1254, 1267, 1255, 1254, 1267, 1265, 1254, 1381,
     1255, 1266, 1305, 1267, 1301, 1267, 1319, 1306, 1217, 1319,
     1218, 1219, 1267, 1220, 1221, 1222, 1326, 1223, 1495, 1224,
     1225, 1300, 1328, 1329, 1267, 1217, 1261, 1218, 1219, 1327,
     1220, 1221, 1222, 1305, 1223, 1301, 1224, 1225, 1306, 1381,
     1237, 1275, 1256, 1267, 1183, 1167, 1355, 1183, 1256, 1276,

     1276, 1276, 1276, 1328, 1329, 1154, 1412, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1277, 1154, 1277, 1154, 1278, 1278, 1278,
     1278, 1278, 1278, 1278, 1278, 1278, 1267, 1491, 1254, 1141,
     1267, 1254, 1141, 1255, 1142, 1207, 1208, 1381, 1154, 1267,
     1154, 1390, 1381, 1209, 1210, 1154, 1154, 1211, 1212,  993,
     1213, 1381, 1336, 1337, 1214, 1302, 1154, 1267, 1303, 1537,
     1350, 1267, 1308, 1350,  417,  879, 1381,  417, 1267, 1154,
     1267, 1154, 1320, 1321, 1216, 1141, 1381, 1154, 1141, 1537,

     1142, 1256, 1143, 1336, 1337, 1381, 1302, 1154, 1178, 1303,
     1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1267,
     1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
     1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
     1307, 1307, 1307, 1307, 1307, 1307,  749, 1381, 1143, 1358,
     1000, 1001, 1331, 1381, 1359, 1381, 1217, 1396, 1218, 1219,
     1154, 1220, 1221, 1222, 1154, 1223, 1332, 1224, 1225, 1207,
     1208, 1141,  977, 1154, 1141, 1381, 1142, 1209, 1210,  976,
     1358, 1211, 1212, 1331, 1213, 1359, 1381, 1381, 1214, 1381,
     1161, 1154, 1381, 1381, 1162, 1154, 1309, 1332, 1333, 1144,

      980, 1334, 1402,  977, 1154, 1381,  799,  800, 1216, 1161,
      976, 1154, 1145,  988,  801,  802, 1351, 1352,  803,  804,
     1381,  805, 1483, 1381, 1143,  806,  976, 1168, 1169, 1333,
     1144,  980, 1334, 1339,  736,  737,  738,  736,  736,  737,
      738,  736, 1154, 1145,  988,  808, 1165, 1165, 1165, 1165,
     1165, 1165, 1165, 1165, 1165, 1369,  737, 1370, 1369, 1372,
      737, 1373, 1372, 1375,  737, 1376, 1375, 1381, 1381, 1381,
     1217, 1381, 1218, 1219, 1381, 1220, 1221, 1222, 1470, 1223,
     1469, 1224, 1225, 1381,  799,  800,  736,  737,  738,  736,
     1176, 1381,  801,  802, 1381, 1381,  803,  804, 1154,  805,

      978,  979, 1381,  806, 1381, 1381, 1348,  809, 1149,  810,
      811, 1340,  812,  813,  814, 1381,  815, 1141,  816,  817,
     1141, 1388, 1383,  808, 1381, 1154,  981, 1146,  990, 1154,
      982,  978,  979, 1381,  983, 1381, 1381, 1155, 1381, 1149,
      984,  991, 1381, 1330, 1141, 1400,  985, 1141, 1156, 1383,
     1147, 1403, 1388,  986,  799,  800, 1154,  981, 1146, 1468,
     1381,  982,  801,  802, 1381,  983,  803,  804, 1155,  805,
     1143,  984, 1467,  806,  994, 1157, 1381,  985, 1160, 1156,
     1381,  807, 1381, 1381,  995,  809,  996,  810,  811, 1328,
      812,  813,  814,  808,  815, 1381,  816,  817,  592,  592,

      592,  592, 1381, 1382, 1159, 1466, 1157, 1381,  982, 1160,
     1325, 1154, 1347, 1325, 1329, 1381, 1154, 1326, 1381, 1146,
     1328, 1159, 1173, 1148,  799,  800,  987,  982, 1150, 1174,
     1327, 1381,  801,  802, 1381, 1341,  803,  804, 1146,  805,
     1151, 1141, 1154,  806, 1141, 1329, 1383, 1154, 1381, 1152,
     1381,  807, 1381, 1153, 1381,  809, 1407,  810,  811, 1150,
      812,  813,  814,  808,  815, 1154,  816,  817, 1381, 1141,
     1381, 1151, 1141, 1381, 1383, 1381, 1343, 1381, 1465, 1154,
     1152, 1164, 1154, 1164, 1153, 1165, 1165, 1165, 1165, 1165,
     1165, 1165, 1165, 1165, 1143, 1381, 1154, 1459, 1154, 1381,

     1343, 1458, 1154, 1166, 1331, 1381, 1345, 1381, 1389, 1404,
     1154, 1154, 1384, 1154, 1141, 1381, 1336, 1141, 1332, 1383,
     1337, 1381, 1143, 1381, 1428,  809, 1345,  810,  811, 1154,
      812,  813,  814, 1154,  815, 1331,  816,  817, 1394, 1389,
     1381, 1333, 1154, 1350, 1334, 1199, 1350, 1336, 1381, 1332,
     1325, 1337, 1388, 1325, 1154, 1381, 1389, 1381, 1396, 1398,
     1399,  799,  800, 1398, 1399, 1381, 1381, 1143, 1411,  801,
      802,  749, 1333,  803,  804, 1334,  805, 1381, 1154,  749,
      806, 1381, 1381, 1388, 1381, 1154, 1457, 1389, 1339, 1165,
     1165, 1165, 1165, 1165, 1165, 1165, 1165, 1165, 1325, 1344,

      808, 1325,  799,  800, 1405, 1406, 1408, 1409, 1145, 1154,
      801,  802, 1410, 1145,  803,  804, 1456,  805, 1381, 1141,
     1391,  806, 1141, 1344, 1383, 1381, 1386, 1381, 1386, 1340,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1145,
     1381,  808, 1381, 1606, 1145, 1606, 1405, 1406, 1384, 1341,
      982, 1391, 1392, 1606, 1606, 1606, 1606, 1154, 1154, 1391,
     1420,  982,  809, 1498,  810,  811, 1393,  812,  813,  814,
     1407,  815, 1143,  816,  817, 1325, 1392, 1439, 1325, 1351,
     1352,  982, 1393, 1392, 1420, 1408, 1409, 1498, 1154, 1154,
     1391, 1141,  982, 1440, 1141, 1488, 1142, 1393, 1415, 1439,

     1416, 1455, 1432,  809, 1454,  810,  811, 1392,  812,  813,
      814, 1451,  815, 1393,  816,  817, 1386, 1488, 1386, 1146,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1387, 1415,
     1154, 1416, 1418, 1432, 1451, 1419, 1372,  737, 1373, 1372,
     1424,  737, 1370, 1424, 1143, 1424,  737, 1370, 1424, 1450,
     1146, 1449, 1418, 1424,  737, 1370, 1424, 1419, 1154, 1389,
     1448, 1154, 1425,  737, 1373, 1425, 1425,  737, 1373, 1425,
     1425,  737, 1373, 1425, 1426,  737, 1376, 1426, 1426,  737,
     1376, 1426, 1426,  737, 1376, 1426,  799,  800, 1141, 1154,
     1389, 1141, 1433, 1142,  801,  802, 1452, 1141,  803,  804,

     1141,  805, 1142, 1141, 1141,  806, 1141, 1141, 1142, 1142,
     1446, 1409, 1453,  807, 1387, 1387, 1387, 1387, 1387, 1387,
     1387, 1387, 1387, 1433, 1434,  808, 1434, 1452, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1441, 1442, 1460,
     1461, 1430, 1484, 1453,  736,  737,  738,  736, 1463, 1464,
     1431, 1424,  737, 1370, 1424, 1485, 1143, 1143, 1538, 1441,
     1442, 1425,  737, 1373, 1425, 1426,  737, 1376, 1426, 1606,
     1460, 1461, 1141, 1484, 1606, 1141, 1141, 1142, 1538, 1141,
     1493, 1142, 1606, 1606, 1606, 1606, 1485,  809, 1494,  810,
      811, 1447,  812,  813,  814, 1407,  815, 1445,  816,  817,

     1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435, 1435,  799,
      800, 1493,  749,  736,  737,  738,  736,  801,  802, 1494,
     1154,  803,  804,  749,  805,  799,  800, 1141,  806, 1143,
     1141, 1444, 1142,  801,  802, 1443, 1472,  803,  804, 1472,
      805, 1473, 1476,  749,  806, 1476, 1480, 1477,  808, 1480,
     1141, 1481, 1440, 1141,  749, 1142, 1496, 1141, 1438, 1497,
     1141, 1489, 1142, 1489,  808, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1490, 1490, 1606, 1436, 1496, 1515, 1516, 1428,
     1143, 1497, 1606, 1606, 1606, 1606, 1427, 1476, 1502, 1474,
     1476, 1502, 1477, 1473, 1533, 1478, 1423, 1502, 1422, 1482,

     1502, 1502, 1473, 1143, 1502, 1535, 1473, 1421, 1515, 1516,
      809, 1417,  810,  811, 1536,  812,  813,  814, 1533,  815,
     1502,  816,  817, 1502, 1417, 1473,  809, 1534,  810,  811,
     1154,  812,  813,  814, 1414,  815, 1535,  816,  817, 1505,
     1478, 1474, 1505, 1505, 1477, 1536, 1505, 1412, 1477, 1154,
     1474, 1534, 1505, 1505, 1474, 1505, 1505, 1477, 1477, 1508,
     1508, 1154, 1508, 1508, 1481, 1481, 1508, 1508, 1411, 1508,
     1508, 1481, 1481, 1474,  736,  737,  738,  736, 1539, 1410,
     1154, 1404, 1503, 1490, 1490, 1490, 1490, 1490, 1490, 1490,
     1490, 1490, 1478, 1560, 1141, 1504, 1478, 1141, 1502, 1142,

     1539, 1502, 1559, 1473, 1582, 1478, 1478, 1583, 1403, 1402,
     1561, 1505, 1482, 1482, 1505, 1506, 1477, 1560, 1508, 1482,
     1482, 1508, 1606, 1481, 1559, 1562, 1582, 1583, 1507, 1509,
     1606, 1606, 1606, 1606, 1561, 1502, 1401, 1400, 1502, 1584,
     1473, 1585, 1510,  736,  737,  738,  736, 1143, 1523, 1562,
     1523, 1474, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1584, 1397, 1502, 1478, 1585, 1502, 1502, 1473, 1396,
     1502, 1482, 1473, 1471, 1505, 1505, 1594, 1505, 1505, 1477,
     1477, 1471, 1471, 1471, 1471, 1590, 1589, 1527, 1474, 1527,
     1598, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,

     1594, 1591, 1595, 1396, 1512, 1502, 1589, 1590, 1502, 1395,
     1473, 1394, 1598, 1606, 1505, 1521, 1541, 1505, 1390, 1477,
     1542, 1591, 1595, 1522, 1522, 1522, 1522, 1478, 1544, 1381,
     1381, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1599, 1474, 1505,
     1602, 1603, 1505, 1380, 1477, 1378, 1377, 1545, 1508, 1525,
     1367, 1508, 1366, 1481, 1365, 1364, 1363, 1526, 1526, 1526,
     1526, 1599, 1602, 1603, 1362, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,

     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1355, 1478, 1508, 1508, 1354, 1508, 1508, 1481, 1481,
     1353, 1547, 1141, 1529, 1349, 1141, 1348, 1142, 1347, 1346,
     1342, 1530, 1530, 1530, 1530,  736,  737,  738,  736, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1508, 1482, 1548, 1508, 1341,
     1481, 1166,  976, 1335, 1502, 1143, 1330, 1502, 1531, 1473,
     1531, 1605, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1532, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,

     1475, 1324, 1323, 1605, 1479, 1322, 1318, 1317, 1475, 1475,
     1475, 1475, 1479, 1479, 1479, 1479, 1316, 1315, 1482, 1502,
     1311, 1310, 1502, 1279, 1473, 1226, 1502, 1474, 1304, 1502,
     1141, 1473, 1299, 1141, 1502, 1142, 1293, 1502, 1505, 1473,
     1292, 1505, 1291, 1477, 1290, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1289, 1474, 1505, 1288, 1285, 1505, 1284, 1477, 1542,
     1283, 1271, 1253, 1143, 1471, 1505, 1252, 1541, 1505, 1249,
     1477, 1545, 1471, 1471, 1471, 1471, 1248, 1247, 1243, 1543,

     1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543,
     1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543,
     1543, 1543, 1543, 1543, 1543, 1505, 1478, 1216, 1505, 1242,
     1477, 1239, 1202, 1201, 1508, 1201, 1200, 1508, 1544, 1481,
     1199, 1198, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1551, 1475, 1197, 1043, 1195, 1479,  749, 1194, 1193, 1475,
     1475, 1475, 1475, 1479, 1479, 1479, 1479, 1190, 1478, 1508,
     1502, 1188, 1508, 1502, 1481, 1473, 1502, 1482, 1182, 1502,
     1505, 1473, 1180, 1505, 1505, 1477, 1179, 1505, 1508, 1477,

     1178, 1508, 1177, 1481, 1176, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546, 1546,
     1546, 1508, 1482, 1474, 1508, 1508, 1481, 1175, 1508, 1474,
     1481, 1172, 1503, 1478, 1171, 1170, 1162, 1478, 1554, 1158,
     1140, 1482, 1506, 1139, 1508, 1553, 1556, 1508, 1138, 1481,
     1509, 1504, 1137, 1141, 1136, 1555, 1141, 1141, 1142, 1507,
     1141, 1135, 1142, 1557, 1132, 1131, 1130, 1502, 1118, 1100,
     1502, 1099, 1473, 1096, 1482, 1095, 1094, 1090, 1548, 1063,
     1563, 1089, 1563, 1558, 1564, 1564, 1564, 1564, 1564, 1564,

     1564, 1564, 1564, 1086, 1049, 1048, 1510, 1547, 1047, 1046,
     1040, 1039, 1038, 1037, 1036, 1033, 1143, 1032, 1032, 1028,
     1143, 1022, 1018, 1006, 1006, 1005, 1005, 1003, 1002,  999,
     1474, 1565,  998,  997,  993,  808,  992,  989,  975, 1566,
     1566, 1566, 1566,  974,  971,  970,  969, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1505,  965,  938, 1505,  964, 1477,  961,
      924,  923,  922,  921,  917,  916, 1567,  915, 1567,  914,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568,  910,

      909,  757,  559,  906,  901,  737,  894,  892,  891,  889,
      889,  888,  888,  881,  696,  877,  865,  865,  862,  862,
      860,  860,  861,  859,  833,  825, 1478, 1569,  819,  819,
      776,  776,  774,  774,  772, 1570, 1570, 1570, 1570,  771,
      770,  769,  768, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570,
     1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1570, 1508,
      767,  766, 1508,  763, 1481,  762,  761,  753,  556,  553,
      732,  728, 1571,  727, 1571,  726, 1572, 1572, 1572, 1572,
     1572, 1572, 1572, 1572, 1572,  725,  724,  724,  717, 1606,

      311,  701,  700,  699,  498,  698,  693,  693, 1606, 1606,
     1606,  652, 1606, 1606, 1606,  466, 1606,  609,  609,  608,
      608,  600, 1482, 1573,  599,  598,  597,  596,  595,  594,
      590, 1574, 1574, 1574, 1574,  590,  588,  588,  585, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1574, 1574, 1574, 1574, 1502,  584,  583, 1502,  580,
     1473,  579,  578,  574,  376,  573,  572,  366,  363,  554,
      553,  355, 1564, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564,  547, 1505,  546,  545, 1505,  544, 1477,  543,  542,

      536,  536,  535,  535,  531,  530,  528,  527,  524, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1474, 1579,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1478, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1508,  152,  311, 1508,  507, 1481,  507,  502,
      502,  500,  500,  501,  499,  497,  291,  491,  486, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572,  485,  482,

      473,  469,  466, 1606,  409,  407,  405,  227,  225,  220,
      393,  389,  391,  389,  387,  386,  208,  202,  205,  204,
      195,  204,  349,  348,  347, 1482, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   56,   56,   56,   56,   56,   56,
       56,   56,   56,   56,   56,   68,   68,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   73,   73,   73,   73,

       73,   73,   73,   73,   73,   73,   73,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   94,
       94,   94,   94,   94,   94,   94,   94,   94,   94,   94,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,  101,  101,  101,  101,  101,  101,  101,  101,  101,
      101,  101,  114,  114,  114,  114,  114,  114,  114,  114,
      114,  114,  114,  128,  128,  128,  128,  162,  162,  346,
      162,  162,  162,  162,  162,  162,  162,  162,  172,  345,
      344,  331,  172,  172,  172,  172,  172,  172,  172,  177,

      177,  152,  305,  177,  177,  177,  177,  177,  177,  177,
      183,  183,  303,  183,  183,  183,  183,  183,  183,  183,
      183,  185,  300,  299,  278,  185,  185,  185,  185,  185,
      185,  185,  187,  277,  239,  125,  187,  187,  187,  187,
      187,  187,  187,  189,  124,  239,  104,  189,  189,  189,
      189,  189,  189,  189,  206,  206,  224,  206,  206,  206,
      206,  206,  206,  206,  206,  214,  214,  223,  214,  214,
      214,  214,  214,  214,  214,  214,  219,  219,  213,  219,
      219,  219,  219,  219,  219,  219,  219,  229,  229,  212,
      229,  229,  229,  229,  229,  229,  229,  229,  245,  245,

      245,  245,  245,  245,  245,  245,  245,  245,  245,  128,
      128,  128,  128,  280,  280,  211,  280,  280,  280,  280,
      280,  280,  280,  280,  282,  282,  210,  282,  282,  282,
      282,  282,  282,  282,  282,  290,  290,  205,  290,  290,
      290,  290,  290,  290,  290,  290,  295,  295,  204,  295,
      295,  295,  295,  295,  295,  295,  295,  301,  200,  301,
      301,  302,  302,  304,  188,  186,  304,  304,  172,  184,
      182,  181,  172,  172,  172,  172,  172,  172,  172,  177,
      177,  180,  179,  177,  177,  177,  177,  177,  177,  177,
      183,  183,  173,  183,  183,  183,  183,  183,  183,  183,

      183,  185,  171,  161,  160,  185,  185,  185,  185,  185,
      185,  185,  187,  156,  127,  125,  187,  187,  187,  187,
      187,  187,  187,  189,  124,  108, 1606,  189,  189,  189,
      189,  189,  189,  189,  353,  353,  353,  353,  353,  353,
      353,  353,  353,  353,  353,  362,  362,  102,  362,  362,
      362,  362,  362,  362,  362,  362,  388,  388,  102,  388,
      388,  388,  388,  388,  388,  388,  388,  390,  390,   38,
      390,  390,  390,  390,  390,  390,  390,  390,  219,  219,
       38,  219,  219,  219,  219,  219,  219,  219,  219,  229,
      229, 1606,  229,  229,  229,  229,  229,  229,  229,  229,

      417,  417,  417,  417,  417,  417,  417,  417,  417,  417,
      417,  290,  290, 1606,  290,  290,  290,  290,  290,  290,
      290,  290,  496,  496, 1606,  496,  496,  496,  496,  496,
      496,  496,  496,  280,  280, 1606,  280,  280,  280,  280,
      280,  280,  280,  280,  498,  498, 1606,  498,  498,  498,
      498,  498,  498,  498,  498,  503,  503, 1606,  503,  503,
      503,  503,  503,  503,  503,  503,  504,  504, 1606,  504,
      504,  504,  504,  504,  504,  504,  504,  505,  505,  505,
      505,  505, 1606,  505,  505,  505,  505,  505,  506,  506,
     1606,  506,  506,  506,  506,  506,  506,  506,  506,  509,

      509,  510,  510,  510,  510, 1606,  510,  510,  510,  510,
      510,  510,  511,  511,  511,  511,  511, 1606,  511,  511,
      511,  511,  511,  548,  548, 1606,  548,  548,  548,  548,
      548,  548,  548,  548,  353,  353,  353,  353,  353,  353,
      353,  353,  353,  353,  353,  555,  555, 1606,  555,  555,
      555,  555,  555,  555,  555,  555,  586,  586, 1606,  586,
      586,  586,  586,  586,  586,  586,  586,  587,  587, 1606,
      587,  587,  587,  587,  587,  587,  587,  587,  589,  589,
     1606,  589,  589,  589,  589,  589,  589,  589,  589,  593,
      593, 1606,  593,  593,  593,  593,  593,  593,  593,  593,

      601,  601, 1606,  601,  601,  601,  601,  601,  601,  601,
      601,  229,  229, 1606,  229,  229,  229,  229,  229,  229,
      229,  229,  641,  641, 1606,  641,  641,  641,  641,  641,
      641,  641,  641,  643,  643, 1606,  643,  643,  643,  643,
      643,  643,  643,  643,  651,  651, 1606,  651,  651,  651,
      651,  651,  651,  651,  651,  687,  687, 1606,  687,  687,
      687,  687,  687,  687,  687,  687,  691,  691, 1606,  691,
      691,  691,  691,  691,  691,  691,  691,  496,  496, 1606,
      496,  496,  496,  496,  496,  496,  496,  496,  696,  696,
     1606,  696,  696,  696,  696,  696,  696,  696,  696,  697,

      697, 1606,  697,  697,  697,  697,  697,  697,  697,  697,
      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  304,  304,  510,  510,  510,  510,  510,  510,  510,
      510,  510,  510,  510,  511,  511,  511,  511,  511,  511,
      511,  511,  511,  511,  511,  643,  643, 1606,  643,  643,
      643,  643,  643,  643,  643,  643,  548,  548, 1606,  548,
      548,  548,  548,  548,  548,  548,  548,  735,  735, 1606,
      735,  735,  735,  735,  735,  735,  735,  735,  586,  586,
     1606,  586,  586,  586,  586,  586,  586,  586,  586,  773,
      773, 1606,  773,  773,  773,  773,  773,  773,  773,  773,

      775,  775, 1606,  775,  775,  775,  775,  775,  775,  775,
      775,  818,  818, 1606,  818,  818,  818,  818,  818,  818,
      818,  818,  601,  601, 1606,  601,  601,  601,  601,  601,
      601,  601,  601,  820,  820, 1606,  820,  820,  820,  820,
      820,  820,  820,  820,  821,  821, 1606,  821,  821,  821,
      821,  821,  821,  821,  821,  229,  229, 1606,  229,  229,
      229,  229,  229,  229,  229,  229,  822,  822, 1606,  822,
      822,  822,  822,  822,  822,  822,  822,  823,  823, 1606,
      823,  823,  823,  823,  823,  823,  823,  823,  824,  824,
     1606,  824,  824,  824,  824,  824,  824,  824,  824,  417,

      417, 1606,  417,  417,  417,  417,  417,  417,  417,  417,
      832,  832, 1606,  832,  832,  832,  832,  832,  832,  832,
      832,  852,  852, 1606,  852,  852,  852,  852,  852,  852,
      852,  852,  856,  856, 1606,  856,  856,  856,  856,  856,
      856,  856,  856,  641,  641, 1606,  641,  641,  641,  641,
      641,  641,  641,  641,  858,  858, 1606,  858,  858,  858,
      858,  858,  858,  858,  858,  863,  863, 1606,  863,  863,
      863,  863,  863,  863,  863,  863,  864,  864,  864,  864,
      864,  864,  864,  864,  864,  864,  864,  868,  868,  868,
      868,  868,  868,  868,  868,  868,  868,  868,  869,  869,

      869,  869,  869,  869,  869,  869,  869,  869,  869,  870,
      870, 1606,  870,  870,  870,  870,  870,  870,  870,  870,
      871,  871, 1606,  871,  871,  871,  871,  871,  871,  871,
      871,  872,  872, 1606,  872,  872,  872,  872,  872,  872,
      872,  872,  873,  873, 1606,  873,  873,  873,  873,  873,
      873,  873,  873,  874,  874, 1606,  874,  874,  874,  874,
      874,  874,  874,  874,  875,  875, 1606,  875,  875,  875,
      875,  875,  875,  875,  875,  687,  687, 1606,  687,  687,
      687,  687,  687,  687,  687,  687,  876,  876, 1606,  876,
      876,  876,  876,  876,  876,  876,  876,  691,  691, 1606,

      691,  691,  691,  691,  691,  691,  691,  691,  879, 1606,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  858,
      858, 1606,  858,  858,  858,  858,  858,  858,  858,  858,
      548,  548,  548,  548,  548,  548,  548,  548,  548,  548,
      548,  897,  897, 1606,  897,  897,  897,  897,  897,  897,
      897,  897,  925,  925, 1606,  925,  925,  925,  925,  925,
      925,  925,  925,  773,  773, 1606,  773,  773,  773,  773,
      773,  773,  773,  773,  926,  926, 1606,  926,  926,  926,
      926,  926,  926,  926,  926,  775,  775, 1606,  775,  775,
      775,  775,  775,  775,  775,  775, 1004, 1004, 1606, 1004,

     1004, 1004, 1004, 1004, 1004, 1004, 1004,  818,  818, 1606,
      818,  818,  818,  818,  818,  818,  818,  818,  820,  820,
     1606,  820,  820,  820,  820,  820,  820,  820,  820,  821,
      821, 1606,  821,  821,  821,  821,  821,  821,  821,  821,
      822,  822, 1606,  822,  822,  822,  822,  822,  822,  822,
      822,  823,  823, 1606,  823,  823,  823,  823,  823,  823,
      823,  823,  824,  824, 1606,  824,  824,  824,  824,  824,
      824,  824,  824,  832,  832, 1606,  832,  832,  832,  832,
      832,  832,  832,  832, 1008, 1008, 1606, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1008, 1009, 1009, 1606, 1009, 1009,

     1009, 1009, 1009, 1009, 1009, 1009, 1010, 1010, 1606, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1011, 1011, 1606,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1012, 1012,
     1606, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1013,
     1013, 1606, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
      852,  852, 1606,  852,  852,  852,  852,  852,  852,  852,
      852, 1014, 1014, 1606, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014,  856,  856, 1606,  856,  856,  856,  856,  856,
      856,  856,  856, 1016, 1016, 1606, 1016, 1016, 1016, 1016,
     1016, 1016, 1016, 1016,  864,  864,  864,  864,  864,  864,

      864,  864,  864,  864,  864,  868,  868,  868,  868,  868,
      868,  868,  868,  868,  868,  868,  869,  869,  869,  869,
      869,  869,  869,  869,  869,  869,  869,  870,  870, 1606,
      870,  870,  870,  870,  870,  870,  870,  870,  871,  871,
     1606,  871,  871,  871,  871,  871,  871,  871,  871,  872,
      872, 1606,  872,  872,  872,  872,  872,  872,  872,  872,
      873,  873, 1606,  873,  873,  873,  873,  873,  873,  873,
      873,  874,  874, 1606,  874,  874,  874,  874,  874,  874,
      874,  874,  875,  875, 1606,  875,  875,  875,  875,  875,
      875,  875,  875,  876,  876, 1606,  876,  876,  876,  876,

      876,  876,  876,  876,  879, 1606,  879,  879,  879,  879,
      879,  879,  879,  879,  879, 1025, 1025, 1606, 1025, 1025,
     1025, 1025, 1025, 1025, 1025, 1025, 1050, 1050, 1606, 1050,
     1050, 1050, 1050, 1050, 1050, 1050, 1050, 1051, 1051, 1606,
     1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 1163, 1606,
     1163, 1163, 1181, 1181, 1606, 1181, 1181, 1181, 1181, 1181,
     1181, 1181, 1181, 1008, 1008, 1606, 1008, 1008, 1008, 1008,
     1008, 1008, 1008, 1008, 1009, 1009, 1606, 1009, 1009, 1009,
     1009, 1009, 1009, 1009, 1009, 1010, 1010, 1606, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1011, 1011, 1606, 1011,

     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1012, 1012, 1606,
     1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1013, 1013,
     1606, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1014,
     1014, 1606, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184, 1184,
     1184, 1185, 1185, 1606, 1185, 1185, 1185, 1185, 1185, 1185,
     1185, 1185, 1203, 1203, 1606, 1203, 1203, 1203, 1203, 1203,
     1203, 1203, 1203, 1204, 1204, 1606, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1356, 1356, 1606, 1356, 1356, 1356,
     1356, 1356, 1356, 1356, 1356, 1357, 1357, 1606, 1357, 1357,

     1357, 1357, 1357, 1357, 1357, 1357, 1368, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 1368, 1368, 1368, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1374, 1374,
     1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1379,
     1379, 1606, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
     1163, 1606, 1163, 1606, 1163, 1163, 1385, 1606, 1385, 1606,
     1385, 1385, 1413, 1413, 1606, 1413, 1413, 1413, 1413, 1413,
     1413, 1413, 1413, 1437, 1606, 1437, 1437, 1471, 1471, 1606,
     1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1475, 1475,
     1606, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1475, 1479,

     1479, 1606, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479,
     1492, 1606, 1492, 1492,   37, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606
    } ;

static const flex_int16_t yy_chk[7758] =
    {   0,
        0,    0,    3,    3,    4,    4,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    7,    7,
        7,    7,    8,    8,    8,    8,   15,    9,   10,   25,
       25,   25,   25,    7,   27,   27,   27,    8,   26,   26,
       26,   26,  250,   25,   25,    9,   10,   28,   28,   28,
       29,   30,   26,   26,   33,   33,  250,   29,   30,   34,
       34,   15,  654,   48,   29,   30,   48,   15, 1790,   15,

      654,    7,    9,   10,   59,    8,  233,   59,   40,   40,
       40,   40,   25,  233,   25,   66,   66,   40,   66,   87,
       87,   26,   15,   26,   40, 1785,   67, 1783,   15,   67,
       15,  284,  284,    9,   10,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   16,
       43,   43,   43,   43,  260,  135,   55,   44,   44,   44,
       44,   55,  368,  260,   43,   43,   44,   44,   86,   86,
       86,   86,   44,   44,   60,   60,   60,   60,   60,   60,
       60,   99,   99, 1773,   16,   91,   91,   91,   91,  369,
       16,  111,   16,  368,  111, 1683,   99,  135,   55,  103,
      103,  103,  103,   43,  104,  104,  126,  269,  127,  126,
       44,  127,  104,  136,  139,   16,  136,  139,  269,  104,
      369,   16,  139,   16,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       45,   45,   45,   45,  370,  164,  165,  155,  164,  165,
      150,   52,  155,  130,   52,   45,  130, 1661,   53,   53,
       53,   53,  248,   83,  150,   52,   83,   53,   53,   84,
       84,   84,   84,  138,   53,  370,  138,   83,   83,  296,
      296,  148,  138,   97,  148,  166,   97,  517,  166,  155,
      148,  311,  311,   45,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   52,   51,  130,  197,   51,   51,
       51,   53,  167,   84,  248,  167,   83,  108,  108,  108,

      108, 1652,   84,  150,   84,   97,  108,  197,  249,  113,
       51,  150,  159,  108,   97,  159,  113,  321,  197,  168,
      159,  113,  168,  113,  169,   51,   51,  169,  321,   51,
       51,   51,   51,   51,   51,   51,   97,   51,  197,  170,
       51,   51,  170,   51,   51,   51,  517,   51,   51,   51,
       51,   51,   51,   51,  107,   51,   51,   51,  113,  420,
      249,  107,  109,  109,  109,  109,  107,  270,  270,  270,
      107,  107,  107,  420,  107,  440,  109,  109,  110,  110,
      110,  110,  113,  115,  115,  115,  115,  436,  177,  107,
      113,  177,  457,  110,  116,  116,  116,  116,  115,  325,

      325,  424,  107,  116,  116,  117,  117,  117,  117,  116,
      116,  178, 1603,  149,  178,  109,  149,  787,  236,  239,
      117,  236,  239,  123,  123,  123,  123,  149,  328,  328,
      787,  110,  123,  123,  204,  440,  115,  204,  123,  123,
     1244,  151,  151,  151,  151,  383,  383,  116,  132,  132,
      132,  132,  132,  132,  132,  132,  436,  134,  117,  121,
      121,  134,  121,  134,  134,  265,  149,  457,  265,  134,
      162,  162,  162,  162,  134,  121,  123,  134,  371,  152,
      152,  152,  152,  424,  220,  220,  121,  204,  152,  152,
      223,  223,  121,  121,  151,  152,  121,  423,  121,  220,

      121,  423,  121,  121,  121,  223,  121,  240,  121,  371,
      240,  443,  121,  154,  154,  240,  154,  121,  154,  121,
      241,  121,  275,  241,  121,  275,  154,  154,  241,  121,
      411,  411,  152,  154,  121,  122,  122,  122,  122,  122,
      122,  122,  122,  122,  122,  276,  122,  514,  276,  122,
      122,  122,  147,  276,  147,  572,  147,  147,  147,  147,
      147,  147,  147,  147,  147, 1244,  156,  156,  156,  156,
      190,  122,  443,  190,  572,  156,  156,  191,  191,  191,
      191,  429,  156,  761,  190,  190,  122,  122,  414,  414,
      122,  122,  122,  122,  122,  122,  122, 1599,  122,  372,

      194,  122,  122,  194,  122,  122,  122,  761,  122,  122,
      122,  122,  122,  122,  122,  194,  122,  122,  122,  156,
      157,  429,  514,  190,  157,  163,  157,  157,  163,  807,
      372,  432,  157,  192,  192,  192,  192,  157,  253,  253,
      157,  253,  807,  163,  163,  163,  163,  217,  192,  195,
      195,  195,  195,  194,  200,  200,  200,  200,  201,  201,
      201,  201,  202,  202,  202,  202,  207,  207,  207,  207,
      210,  210,  210,  210,  222,  217,  222, 1598,  431,  261,
      227,  227,  261,  374,  516,  222,  217,  222,  227,  222,
      432,  230,  217,  195,  230,  227,  222,  231,  200,  432,

      231,  463,  195,  519,  195,  463,  217,  200,  261,  200,
      208,  208,  208,  208,  374,  234,  238,  217,  431, 1034,
      261,  234,  222,  217,  231,  230,  234,  238,  242,  242,
      242,  242,  234,  238,  230, 1034,  208,  208,  234,  279,
      231, 1034,  279,  242,  208,  208,  231,  238,  208,  208,
      256,  208,  234,  256,  331,  208,  516,  331,  238,  243,
      243,  243,  243,  234,  238,  244,  244,  244,  244,  234,
      246,  246,  246,  246,  243,  208,  247,  247,  247,  247,
      244,  242,  519,  258,  256,  246,  258,  262,  439,  293,
      262,  247,  293,  256,  262, 1595,  308,  332,  293,  308,

      332,  379,  493,  493,  262,  308,  313,  313,  263,  313,
      258,  379,  243,  379,  263,  578,  272,  333,  244,  263,
      333,  520,  578,  246,  258,  263,  258,  272,  573,  247,
      664,  263,  258,  272,  664,  334, 1594,  208,  334,  208,
      208,  937,  208,  208,  208,  263,  208,  272,  208,  208,
      251,  251,  762,  251,  937,  272,  263,  324,  272,  313,
      324,  439,  263, 1248,  272,  324,  251,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  762,  251,  335,  318,
     1591,  335,  318,  251,  251,  336,  560,  251,  336,  251,
      573,  251,  868,  251,  251,  251,  868,  251,  337,  251,

      520,  337,  969,  251,  310,  310,  310,  310,  251,  969,
      251,  338,  251,  318,  338,  251,  339,  560,  340,  339,
      251,  340,  318,  532,  532,  251,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  341,  252,  561,  341,
      252,  252,  252,  342,  343, 1589,  342,  343,  350,  350,
      350,  350,  402,  352,  318,  402,  352,  310,  403,  318,
     1585,  403,  252,  351,  351,  351,  351,  563,  352,  561,
      355,  355,  355,  355,  574,  574,  354,  252,  252,  354,
      668,  252,  252,  252,  252,  252,  252,  252,  668,  252,
     1248,  354,  252,  252, 1289,  252,  252,  252,  563,  252,

      252,  252,  252,  252,  252,  252,  352,  252,  252,  252,
      315,  315, 1584,  315,  355,  357,  361,  361,  361,  361,
      763,  404,  442,  355,  404,  355,  315,  645,  645,  354,
      366,  366,  366,  366, 1222,  357,  315,  315,  565,  315,
      763,  315,  405,  315,  315,  405,  357,  315, 1583,  315,
      315,  315,  864,  315,  315,  315,  315,  315,  406,  315,
      864,  406,  407,  315,  408,  407,  357,  408,  315,  565,
      315,  409,  315,  437,  409,  315,  392,  392,  392,  392,
      315,  392,  442,  442,  442,  315,  316,  316,  316,  316,
      316,  316,  316,  316,  316,  316,  410,  316,  566,  410,

      316,  316,  316,  869,  567,  418,  418,  418,  418,  425,
      425,  869,  425,  419,  419,  419,  419,  743,  426,  426,
      418,  426,  316, 1289,  421,  421,  421,  421,  419,  566,
      437,  446,  446,  437,  446,  567,  743,  316,  316,  421,
     1222,  316,  316,  316,  316,  316,  316,  316,  441,  316,
      568,  468,  316,  316,  468,  316,  316,  316,  418,  316,
      316,  316,  316,  316,  316,  316,  419,  316,  316,  316,
      363,  363,  363,  363, 1281,  373,  422,  421,  422,  373,
     1562,  568,  571,  373,  446,  422,  518,  739,  467,  373,
      422,  467,  422,  467,  741,  373,  363,  363,  428,  428,

      469,  428,  373,  469,  363,  363,  373,  434,  363,  363,
      373,  363,  441,  571,  373,  363,  433,  433,  739,  433,
      373,  430,  430,  441,  430,  741,  373,  422,  453,  453,
     1221,  453,  428,  434,  470,  363,  434,  470,  655,  655,
      434,  428,  435,  471,  444,  433,  471, 1132,  430,  451,
      434,  422,  744,  451,  518,  451,  451,  433, 1281,  422,
      472,  451,  430,  472,  430,  518,  451, 1132,  435,  451,
      430,  710,  710, 1292,  435,  373,  444,  455,  455,  435,
      455,  465,  465,  744,  465,  435,  455,  444,  745,  473,
      465,  435,  473,  444,  747,  474, 1220,  363,  474,  363,

      363, 1172,  363,  363,  363,  435,  363,  444,  363,  363,
      448,  713,  713, 1221,  456,  444,  435,  475,  444,  745,
      475, 1172,  435,  438,  444,  747,  919,  448,  448,  448,
      448,  448,  448,  448,  448,  476,  477,  478,  476,  477,
      478,  479,  480,  481,  479,  480,  481,  919,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  456,  482,  483,  456,  482,  483,
      523,  484,  456,  460,  484,  485,  486,  488,  485,  486,
      488,  489,  460,  490,  489,  492,  490, 1220,  492, 1561,

      460,  460,  460,  460,  486, 1252,  750, 1292,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  461,  497,  500,  750,  497,  500,
      523, 1271,  513,  523,  513, 1271,  524,  526,  523,  524,
      526,  486,  527,  528,  529,  527,  528,  529,  513,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  530,  531, 1252,  530,  531,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,

      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  462,  513,  537,  538,
      539,  537,  538,  539,  540,  513,  541,  540,  546,  541,
      964,  546,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  604,  515,
      515,  604,  515,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  464,
     1312,  553,  964,  515,  553,  545,  608,  614,  545,  608,

      614,  464,  515,  464, 1454,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  545,  521, 1455,  610,  562,  521,
      610,  521,  521,  549, 1454,  610,  549,  521,  550,  550,
      550,  550,  521,  570,  515,  521, 1455,  570,  549,  515,
      564,  562, 1560,  550,  553,  559,  559,  559,  559,  562,
      570,  611,  564, 1250,  611,  615,  570,  992,  615,  611,
      615,  564,  752,  616,  617,  564,  616,  617, 1559,  618,
      619,  564,  618,  619,  795,  795,  549,  556,  556,  556,
      556,  620,  621,  564,  620,  621,  622,  623,  624,  622,
      623,  624,  564,  752,  625,  626,  564,  625,  626,  627,

      815,  815,  627,  556,  556,  628,  629,  630,  628,  629,
      630,  556,  556, 1312,  562,  556,  556,  631,  556,  992,
      631,  632,  556,  633,  632,  634,  633,  636,  634,  637,
      636,  638,  637,  640,  638,  653,  640,  673,  653, 1250,
      673,  961,  556,  634,  653,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  667,  674,  675,  667,  674,  675,
      961,  676,  677,  667,  676,  677,  680,  681,  683,  680,
      681,  683,  684,  685,  686,  684,  685,  686,  689,  690,
      692,  689,  690,  692,  694,  695,  699,  694,  695,  699,
      634,  702,  704,  705,  702,  704,  705,  706,  707,  708,

      706,  707,  708, 1214,  556,  709,  556,  556,  709,  556,
      556,  556, 1539,  556, 1216,  556,  556,  591,  591,  591,
      591,  716,  591,  717,  716,  718,  717,  719,  718,  720,
      719,  721,  720,  722,  721,  723,  722,  727,  723,  729,
      727, 1291,  729,  591,  591,  730,  731,  732,  730,  731,
      732,  591,  591, 1216,  737,  591,  591,  737,  591,  754,
      826,  826,  591,  733,  733,  733,  733,  748,  755, 1217,
      591,  734,  734,  734,  734,  736,  736,  736,  736,  756,
     1089,  748,  591,  740,  740,  740,  740,  746,  779,  780,
      754,  746,  749,  749,  749,  749,  781,  782,  748,  755,

      746,  783, 1130,  751,  751,  751,  751,  785,  768,  799,
      756,  768,  748,  791,  800,  829,  829,  801,  746,  779,
      780,  802,  746,  791, 1214,  791, 1130,  781,  782,  811,
      751,  746,  783,  751,  803,  805,  912,  912,  785,  811,
      799,  811, 1089,  751,  591,  800,  591,  591,  801,  591,
      591,  591,  802,  591, 1534,  591,  591,  592,  592,  592,
      592,  751,  592, 1224,  751,  803,  805,  778,  778,  825,
      833, 1291,  825,  833,  751,  778,  778, 1217,  838,  778,
      778,  838,  778,  592,  592,  784,  778,  839,  899,  784,
      839,  592,  592,  784,  778,  592,  592,  840,  592,  784,

      840,  841,  592, 1131,  841,  784,  778, 1286,  842, 1170,
      592,  842,  784, 1533,  845,  846,  784,  845,  846,  899,
      784, 1520,  592,  848,  784,  849,  848, 1131,  849,  850,
      784,  851,  850, 1170,  851,  854,  784,  855,  854,  857,
      855,  900,  857,  860,  768,  768,  860,  877,  878,  880,
      877,  878,  880,  881,  882,  883,  881,  882,  883,  884,
      885,  886,  884,  885,  886, 1511,  887, 1224,  778,  887,
      778,  778,  900,  778,  778,  778, 1501,  778,  890,  778,
      778,  890,  918,  918,  592,  784,  592,  592, 1286,  592,
      592,  592, 1500,  592, 1499,  592,  592,  659,  659,  659,

      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  892,
      893, 1245,  892,  893,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      777,  777,  777,  777,  894,  777,  902,  894,  895,  798,
      798,  895,  896,  898, 1315,  896,  898,  798,  798, 1225,

      903,  798,  798,  904,  798, 1309,  777,  777,  798,  905,
      905,  905,  905,  906,  777,  777,  798,  902,  777,  777,
      907,  777,  804,  908,  929,  777,  804,  930,  798,  931,
      804,  903,  932,  777,  904,  933,  804,  920,  920,  935,
      941,  949,  804,  950,  906,  777,  945,  945,  905,  804,
      941,  907,  941,  804,  908,  929,  952,  804,  930,  989,
      931,  804, 1309,  932,  965,  965,  933,  804, 1005,  954,
      935, 1005,  949,  804,  950,  955, 1245,  956,  989,  905,
      951,  959,  993,  993,  957,  959,  960,  952, 1007,  977,
      798, 1007,  798,  798, 1225,  798,  798,  798,  959,  798,

      954,  798,  798,  951,  959, 1498,  955,  777,  956,  777,
      777,  951,  777,  777,  777,  957,  777,  960,  777,  777,
      977, 1315,  804,  866,  866,  866,  866,  866,  866,  866,
      866,  866,  866,  866,  866,  866,  866,  866,  866,  866,
      866,  866,  866,  866,  866,  866,  866,  866,  866,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867, 1015,  951, 1497, 1015,  978,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,
      867,  867,  867,  867,  867,  867,  867,  867,  867,  867,

      867,  867,  867,  867,  867,  867,  927,  927,  927,  927,
      978,  927,  980,  997,  948,  928,  928,  948, 1018,  948,
      997, 1018, 1021,  928,  928, 1021,  982,  928,  928,  983,
      928, 1282,  927,  927,  928,  979, 1020, 1020,  984, 1020,
      927,  927,  928,  980,  927,  927,  985,  927,  934,  953,
      976,  927,  934,  976,  928,  976,  934,  982,  979,  927,
      983,  953,  934,  988, 1171, 1026,  979,  948,  934,  984,
      953,  927,  987, 1496,  953,  934,  987,  985, 1023,  934,
      953, 1023, 1024,  934, 1028, 1024, 1029,  934, 1171,  987,
     1042, 1042,  953,  934,  988,  987, 1026, 1102, 1030,  934,

     1102,  953,  963,  976,  963,  953,  963,  963,  963,  963,
      963,  963,  963,  963,  963, 1028,  928, 1029,  928,  928,
     1488,  928,  928,  928, 1031,  928, 1483,  928,  928, 1030,
     1062,  979, 1282,  927, 1094,  927,  927, 1086,  927,  927,
      927, 1094,  927, 1062,  927,  927, 1070, 1070,  934,  962,
     1027, 1027, 1027, 1027, 1246, 1031, 1086,  962,  962,  962,
      962, 1032, 1032, 1032, 1032,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  962,  962,  962,  962,  962,  962,  962,  962,  962,
      962,  981, 1036, 1036, 1090, 1090, 1188, 1188, 1066, 1108,

     1103, 1054, 1055,  981, 1056, 1057, 1058, 1060, 1066, 1074,
     1066, 1253,  981, 1103, 1036, 1036,  981, 1142, 1108,  991,
     1142,  991,  981,  991,  991,  991,  991,  991,  991,  991,
      991,  991, 1054, 1055,  981, 1056, 1057, 1058, 1060, 1073,
     1074, 1469, 1073,  981, 1073, 1148, 1075,  981, 1052, 1052,
     1052, 1052, 1182, 1052, 1077, 1182, 1101, 1053, 1053, 1101,
     1079, 1101, 1236, 1293, 1148, 1053, 1053, 1236, 1080, 1053,
     1053, 1081, 1053, 1242, 1052, 1052, 1053, 1075, 1082, 1246,
     1076, 1085, 1052, 1052, 1053, 1077, 1052, 1052, 1104, 1052,
     1059, 1079, 1073, 1052, 1059, 1078, 1053, 1106, 1059, 1080,

     1468, 1052, 1081, 1076, 1059, 1109, 1324, 1078, 1467, 1082,
     1059, 1076, 1085, 1052, 1084, 1110, 1078, 1059, 1084, 1104,
     1078, 1059, 1112, 1253, 1115, 1059, 1078, 1141, 1106, 1059,
     1141, 1084, 1141, 1242, 1464, 1059, 1109, 1084, 1078, 1105,
     1113, 1059, 1105, 1117, 1105, 1114, 1110, 1078, 1114, 1218,
     1114, 1078, 1119, 1112, 1113, 1115, 1137, 1120, 1053, 1137,
     1053, 1053, 1121, 1053, 1053, 1053, 1143, 1053, 1463, 1053,
     1053, 1113, 1144, 1146, 1117, 1052, 1076, 1052, 1052, 1143,
     1052, 1052, 1052, 1119, 1052, 1113, 1052, 1052, 1120, 1251,
     1059, 1087, 1105, 1121, 1183, 1242, 1293, 1183, 1114, 1087,

     1087, 1087, 1087, 1144, 1146, 1149, 1324, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
     1087, 1087, 1087, 1088, 1150, 1088, 1149, 1088, 1088, 1088,
     1088, 1088, 1088, 1088, 1088, 1088, 1111, 1459, 1116, 1145,
     1111, 1116, 1145, 1116, 1145, 1123, 1123, 1299, 1152, 1111,
     1155, 1299, 1223, 1123, 1123, 1150, 1157, 1123, 1123, 1218,
     1123, 1310, 1159, 1160, 1123, 1116, 1161, 1111, 1116, 1517,
     1177, 1111, 1123, 1177, 1184, 1184, 1316, 1184, 1116, 1152,
     1111, 1155, 1137, 1137, 1123, 1154, 1243, 1157, 1154, 1517,

     1154, 1116, 1145, 1159, 1160, 1239, 1116, 1161, 1251, 1116,
     1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1116,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122,
     1122, 1122, 1122, 1122, 1122, 1122, 1457, 1208, 1154, 1186,
     1223, 1223, 1153, 1227, 1187, 1207, 1123, 1310, 1123, 1123,
     1151, 1123, 1123, 1123, 1151, 1123, 1153, 1123, 1123, 1125,
     1125, 1156, 1208, 1151, 1156, 1211, 1156, 1125, 1125, 1207,
     1186, 1125, 1125, 1153, 1125, 1187, 1249, 1228, 1125, 1240,
     1239, 1151, 1213, 1279, 1240, 1151, 1125, 1153, 1156, 1227,

     1211, 1156, 1316, 1208, 1151, 1288, 1163, 1163, 1125, 1239,
     1207, 1156, 1228, 1213, 1163, 1163, 1177, 1177, 1163, 1163,
     1314, 1163, 1450, 1317, 1156, 1163, 1279, 1243, 1243, 1156,
     1227, 1211, 1156, 1163, 1189, 1189, 1189, 1189, 1190, 1190,
     1190, 1190, 1156, 1228, 1213, 1163, 1164, 1164, 1164, 1164,
     1164, 1164, 1164, 1164, 1164, 1197, 1197, 1197, 1197, 1198,
     1198, 1198, 1198, 1199, 1199, 1199, 1199, 1209, 1210, 1268,
     1125, 1215, 1125, 1125, 1230, 1125, 1125, 1125, 1446, 1125,
     1445, 1125, 1125, 1232, 1165, 1165, 1201, 1201, 1201, 1201,
     1249, 1219, 1165, 1165, 1247, 1287, 1165, 1165, 1268, 1165,

     1209, 1210, 1229, 1165, 1233, 1212, 1288, 1163, 1230, 1163,
     1163, 1165, 1163, 1163, 1163, 1234, 1163, 1226, 1163, 1163,
     1226, 1328, 1226, 1165, 1237, 1232, 1212, 1229, 1215, 1268,
     1212, 1209, 1210, 1206, 1212, 1261, 1238, 1233, 1260, 1230,
     1212, 1215, 1235, 1260, 1254, 1314, 1212, 1254, 1234, 1254,
     1229, 1317, 1328, 1212, 1206, 1206, 1232, 1212, 1229, 1444,
     1256, 1212, 1206, 1206, 1257, 1212, 1206, 1206, 1233, 1206,
     1226, 1212, 1443, 1206, 1219, 1235, 1262, 1212, 1238, 1234,
     1259, 1206, 1283, 1263, 1219, 1165, 1219, 1165, 1165, 1257,
     1165, 1165, 1165, 1206, 1165, 1280, 1165, 1165, 1205, 1205,

     1205, 1205, 1318, 1205, 1237, 1442, 1235, 1231, 1237, 1238,
     1255, 1262, 1287, 1255, 1259, 1255, 1263, 1256, 1285, 1261,
     1257, 1237, 1247, 1229, 1205, 1205, 1212, 1237, 1231, 1247,
     1256, 1265, 1205, 1205, 1313, 1351, 1205, 1205, 1261, 1205,
     1231, 1258, 1262, 1205, 1258, 1259, 1258, 1263, 1274, 1231,
     1311, 1205, 1323, 1231, 1270, 1206, 1351, 1206, 1206, 1231,
     1206, 1206, 1206, 1205, 1206, 1265, 1206, 1206, 1308, 1267,
     1272, 1231, 1267, 1241, 1267, 1266, 1283, 1264, 1441, 1270,
     1231, 1241, 1274, 1241, 1231, 1241, 1241, 1241, 1241, 1241,
     1241, 1241, 1241, 1241, 1258, 1322, 1265, 1431, 1264, 1273,

     1283, 1430, 1264, 1280, 1266, 1284, 1285, 1295, 1329, 1318,
     1270, 1264, 1295, 1274, 1269, 1319, 1272, 1269, 1266, 1269,
     1273, 1298, 1267, 1297, 1428, 1205, 1285, 1205, 1205, 1264,
     1205, 1205, 1205, 1264, 1205, 1266, 1205, 1205, 1308, 1329,
     1276, 1269, 1264, 1290, 1269, 1427, 1290, 1272, 1290, 1266,
     1294, 1273, 1297, 1294, 1269, 1294, 1298, 1301, 1311, 1313,
     1313, 1276, 1276, 1344, 1344, 1320, 1300, 1269, 1323, 1276,
     1276, 1423, 1269, 1276, 1276, 1269, 1276, 1277, 1301, 1422,
     1276, 1278, 1302, 1297, 1321, 1269, 1421, 1298, 1276, 1277,
     1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1325, 1284,

     1276, 1325, 1278, 1278, 1350, 1350, 1352, 1352, 1300, 1301,
     1278, 1278, 1322, 1331, 1278, 1278, 1420, 1278, 1296, 1303,
     1302, 1278, 1303, 1284, 1303, 1304, 1296, 1305, 1296, 1278,
     1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1300,
     1307, 1278, 1306, 1326, 1331, 1307, 1319, 1319, 1326, 1320,
     1304, 1302, 1305, 1307, 1307, 1307, 1307, 1332, 1303, 1333,
     1363, 1335, 1276, 1466, 1276, 1276, 1306, 1276, 1276, 1276,
     1320, 1276, 1303, 1276, 1276, 1383, 1336, 1398, 1383, 1290,
     1290, 1304, 1337, 1305, 1363, 1321, 1321, 1466, 1332, 1303,
     1333, 1334, 1335, 1398, 1334, 1456, 1334, 1306, 1358, 1398,

     1359, 1419, 1388, 1278, 1418, 1278, 1278, 1336, 1278, 1278,
     1278, 1412, 1278, 1337, 1278, 1278, 1327, 1456, 1327, 1390,
     1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1358,
     1334, 1359, 1362, 1388, 1411, 1362, 1367, 1367, 1367, 1367,
     1368, 1368, 1368, 1368, 1334, 1369, 1369, 1369, 1369, 1410,
     1390, 1409, 1362, 1370, 1370, 1370, 1370, 1362, 1391, 1392,
     1408, 1334, 1371, 1371, 1371, 1371, 1372, 1372, 1372, 1372,
     1373, 1373, 1373, 1373, 1374, 1374, 1374, 1374, 1375, 1375,
     1375, 1375, 1376, 1376, 1376, 1376, 1382, 1382, 1385, 1391,
     1392, 1385, 1393, 1385, 1382, 1382, 1415, 1387, 1382, 1382,

     1387, 1382, 1387, 1389, 1396, 1382, 1389, 1396, 1389, 1396,
     1406, 1406, 1416, 1382, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1393, 1394, 1382, 1394, 1415, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1400, 1400, 1432,
     1433, 1385, 1452, 1416, 1417, 1417, 1417, 1417, 1438, 1438,
     1387, 1424, 1424, 1424, 1424, 1453, 1389, 1396, 1518, 1400,
     1400, 1425, 1425, 1425, 1425, 1426, 1426, 1426, 1426, 1429,
     1432, 1433, 1490, 1452, 1429, 1490, 1439, 1490, 1518, 1439,
     1460, 1439, 1429, 1429, 1429, 1429, 1453, 1382, 1461, 1382,
     1382, 1407, 1382, 1382, 1382, 1405, 1382, 1404, 1382, 1382,

     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1435,
     1435, 1460, 1484, 1487, 1487, 1487, 1487, 1435, 1435, 1461,
     1403, 1435, 1435, 1485, 1435, 1437, 1437, 1440, 1435, 1439,
     1440, 1402, 1440, 1437, 1437, 1401, 1447, 1437, 1437, 1447,
     1437, 1447, 1448, 1484, 1437, 1448, 1449, 1448, 1435, 1449,
     1451, 1449, 1399, 1451, 1485, 1451, 1465, 1492, 1397, 1465,
     1492, 1458, 1492, 1458, 1437, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1462, 1395, 1465, 1493, 1494, 1378,
     1440, 1465, 1462, 1462, 1462, 1462, 1377, 1470, 1471, 1447,
     1470, 1471, 1470, 1471, 1512, 1448, 1366, 1472, 1365, 1449,

     1472, 1473, 1472, 1451, 1473, 1515, 1473, 1364, 1493, 1494,
     1435, 1361, 1435, 1435, 1516, 1435, 1435, 1435, 1512, 1435,
     1474, 1435, 1435, 1474, 1360, 1474, 1437, 1513, 1437, 1437,
     1535, 1437, 1437, 1437, 1356, 1437, 1515, 1437, 1437, 1475,
     1470, 1471, 1475, 1476, 1475, 1516, 1476, 1355, 1476, 1536,
     1472, 1513, 1477, 1478, 1473, 1477, 1478, 1477, 1478, 1479,
     1480, 1535, 1479, 1480, 1479, 1480, 1481, 1482, 1354, 1481,
     1482, 1481, 1482, 1474, 1486, 1486, 1486, 1486, 1519, 1353,
     1536, 1349, 1474, 1489, 1489, 1489, 1489, 1489, 1489, 1489,
     1489, 1489, 1475, 1550, 1495, 1474, 1476, 1495, 1502, 1495,

     1519, 1502, 1549, 1502, 1575, 1477, 1478, 1576, 1348, 1347,
     1551, 1505, 1479, 1480, 1505, 1478, 1505, 1550, 1508, 1481,
     1482, 1508, 1514, 1508, 1549, 1552, 1575, 1576, 1478, 1482,
     1514, 1514, 1514, 1514, 1551, 1504, 1346, 1345, 1504, 1577,
     1504, 1578, 1482, 1582, 1582, 1582, 1582, 1495, 1504, 1552,
     1504, 1502, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504,
     1504, 1577, 1343, 1522, 1505, 1578, 1522, 1524, 1522, 1342,
     1524, 1508, 1524, 1540, 1507, 1526, 1592, 1507, 1526, 1507,
     1526, 1540, 1540, 1540, 1540, 1587, 1586, 1507, 1504, 1507,
     1596, 1507, 1507, 1507, 1507, 1507, 1507, 1507, 1507, 1507,

     1592, 1588, 1593, 1341, 1486, 1503, 1586, 1587, 1503, 1340,
     1503, 1339, 1596, 1338, 1528, 1503, 1522, 1528, 1330, 1528,
     1524, 1588, 1593, 1503, 1503, 1503, 1503, 1507, 1526, 1275,
     1204, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503,
     1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503,
     1503, 1503, 1503, 1503, 1503, 1503, 1503, 1597, 1503, 1506,
     1600, 1601, 1506, 1203, 1506, 1202, 1200, 1528, 1530, 1506,
     1196, 1530, 1195, 1530, 1194, 1193, 1192, 1506, 1506, 1506,
     1506, 1597, 1600, 1601, 1191, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,

     1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506, 1506,
     1506, 1180, 1506, 1509, 1532, 1179, 1509, 1532, 1509, 1532,
     1178, 1530, 1538, 1509, 1176, 1538, 1175, 1538, 1174, 1173,
     1169, 1509, 1509, 1509, 1509, 1602, 1602, 1602, 1602, 1509,
     1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509,
     1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509,
     1509, 1509, 1509, 1509, 1509, 1510, 1509, 1532, 1510, 1168,
     1510, 1167, 1166, 1158, 1523, 1538, 1147, 1523, 1510, 1523,
     1510, 1604, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1523, 1523, 1523, 1523, 1523, 1523, 1523, 1523, 1523,

     1543, 1140, 1139, 1604, 1546, 1138, 1136, 1135, 1543, 1543,
     1543, 1543, 1546, 1546, 1546, 1546, 1134, 1133, 1510, 1521,
     1129, 1128, 1521, 1127, 1521, 1126, 1564, 1523, 1118, 1564,
     1537, 1564, 1107, 1537, 1566, 1537, 1100, 1566, 1568, 1566,
     1099, 1568, 1098, 1568, 1097, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1096, 1521, 1525, 1095, 1093, 1525, 1092, 1525, 1564,
     1091, 1083, 1072, 1537, 1579, 1570, 1071, 1566, 1570, 1069,
     1570, 1568, 1579, 1579, 1579, 1579, 1068, 1067, 1065, 1525,

     1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1525, 1525, 1527, 1525, 1064, 1527, 1063,
     1527, 1061, 1049, 1048, 1531, 1047, 1046, 1531, 1570, 1531,
     1045, 1044, 1527, 1527, 1527, 1527, 1527, 1527, 1527, 1527,
     1527, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1531,
     1537, 1580, 1043, 1041, 1040, 1581, 1039, 1038, 1037, 1580,
     1580, 1580, 1580, 1581, 1581, 1581, 1581, 1035, 1527, 1529,
     1541, 1033, 1529, 1541, 1529, 1541, 1542, 1531, 1006, 1542,
     1544, 1542, 1003, 1544, 1545, 1544, 1002, 1545, 1547, 1545,

     1001, 1547, 1000, 1547,  999, 1529, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1548, 1529, 1541, 1548, 1572, 1548,  998, 1572, 1542,
     1572,  996, 1541, 1544,  995,  994,  990, 1545, 1542,  986,
      975, 1547, 1544,  974, 1574, 1541, 1545, 1574,  973, 1574,
     1547, 1542,  972, 1590,  971, 1544, 1590, 1605, 1590, 1545,
     1605,  970, 1605, 1547,  968,  967,  966, 1553,  958,  947,
     1553,  946, 1553,  944, 1548,  943,  942,  940, 1572,  939,
     1553,  938, 1553, 1548, 1553, 1553, 1553, 1553, 1553, 1553,

     1553, 1553, 1553,  936,  924,  923, 1548, 1574,  922,  921,
      917,  916,  915,  914,  913,  911, 1590,  910,  909,  901,
     1605,  889,  865,  831,  830,  828,  827,  817,  816,  814,
     1553, 1554,  813,  812,  810,  809,  808,  806,  797, 1554,
     1554, 1554, 1554,  796,  794,  793,  792, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1554, 1554, 1555,  790,  789, 1555,  788, 1555,  786,
      772,  771,  770,  769,  767,  766, 1555,  765, 1555,  764,
     1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555,  760,

      759,  758,  757,  753,  742,  738,  728,  726,  724,  715,
      714,  712,  711,  703,  697,  693,  657,  656,  650,  649,
      648,  647,  646,  644,  613,  609, 1555, 1556,  594,  593,
      590,  589,  588,  587,  585, 1556, 1556, 1556, 1556,  584,
      583,  582,  581, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1556, 1557,
      580,  579, 1557,  577, 1557,  576,  575,  569,  557,  551,
      547,  544, 1557,  543, 1557,  542, 1557, 1557, 1557, 1557,
     1557, 1557, 1557, 1557, 1557,  536,  534,  533,  525,  522,

      512,  511,  510,  507,  506,  505,  495,  494,  459,  458,
      454,  452,  450,  449,  445,  427,  417,  416,  415,  413,
      412,  400, 1557, 1558,  398,  397,  396,  395,  394,  393,
      391, 1558, 1558, 1558, 1558,  390,  389,  388,  386, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1563,  385,  384, 1563,  382,
     1563,  381,  380,  378,  377,  376,  375,  367,  364,  359,
      358,  356, 1563, 1563, 1563, 1563, 1563, 1563, 1563, 1563,
     1563,  349, 1567,  348,  347, 1567,  346, 1567,  345,  344,

      330,  329,  327,  326,  323,  322,  320,  319,  317, 1567,
     1567, 1567, 1567, 1567, 1567, 1567, 1567, 1567, 1563, 1565,
     1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565,
     1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565, 1565,
     1565, 1565, 1565, 1565, 1565, 1567, 1569, 1569, 1569, 1569,
     1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569,
     1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569,
     1569, 1569, 1571,  314,  312, 1571,  298, 1571,  297,  289,
      288,  287,  286,  285,  283,  278,  274,  271,  268, 1571,
     1571, 1571, 1571, 1571, 1571, 1571, 1571, 1571,  267,  264,

      259,  257,  255,  245,  237,  235,  232,  228,  226,  221,
      218,  216,  215,  214,  213,  211,  209,  203,  199,  198,
      196,  193,  182,  181,  180, 1571, 1573, 1573, 1573, 1573,
     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573,
     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573,
     1573, 1573, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607,
     1607, 1607, 1607, 1608, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1609, 1609, 1609, 1609, 1609, 1609,
     1609, 1609, 1609, 1609, 1609, 1610, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1611, 1611, 1611, 1611,

     1611, 1611, 1611, 1611, 1611, 1611, 1611, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1613, 1613,
     1613, 1613, 1613, 1613, 1613, 1613, 1613, 1613, 1613, 1614,
     1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1615, 1615, 1615, 1615, 1615, 1615, 1615, 1615, 1615, 1615,
     1615, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1617, 1617, 1617, 1617, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1618, 1618, 1618, 1618, 1619, 1619,  176,
     1619, 1619, 1619, 1619, 1619, 1619, 1619, 1619, 1620,  175,
      174,  161, 1620, 1620, 1620, 1620, 1620, 1620, 1620, 1621,

     1621,  153,  146, 1621, 1621, 1621, 1621, 1621, 1621, 1621,
     1622, 1622,  145, 1622, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1623,  143,  140,  125, 1623, 1623, 1623, 1623, 1623,
     1623, 1623, 1624,  124,  120,  119, 1624, 1624, 1624, 1624,
     1624, 1624, 1624, 1625,  118,  112,  105, 1625, 1625, 1625,
     1625, 1625, 1625, 1625, 1626, 1626,  102, 1626, 1626, 1626,
     1626, 1626, 1626, 1626, 1626, 1627, 1627,  100, 1627, 1627,
     1627, 1627, 1627, 1627, 1627, 1627, 1628, 1628,   96, 1628,
     1628, 1628, 1628, 1628, 1628, 1628, 1628, 1629, 1629,   95,
     1629, 1629, 1629, 1629, 1629, 1629, 1629, 1629, 1630, 1630,

     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1631,
     1631, 1631, 1631, 1632, 1632,   93, 1632, 1632, 1632, 1632,
     1632, 1632, 1632, 1632, 1633, 1633,   92, 1633, 1633, 1633,
     1633, 1633, 1633, 1633, 1633, 1634, 1634,   89, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1635, 1635,   88, 1635,
     1635, 1635, 1635, 1635, 1635, 1635, 1635, 1636,   85, 1636,
     1636, 1637, 1637, 1638,   81,   78, 1638, 1638, 1639,   75,
       72,   71, 1639, 1639, 1639, 1639, 1639, 1639, 1639, 1640,
     1640,   70,   69, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1641, 1641,   65, 1641, 1641, 1641, 1641, 1641, 1641, 1641,

     1641, 1642,   62,   58,   57, 1642, 1642, 1642, 1642, 1642,
     1642, 1642, 1643,   54,   49,   47, 1643, 1643, 1643, 1643,
     1643, 1643, 1643, 1644,   46,   41,   37, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1646, 1646,   36, 1646, 1646,
     1646, 1646, 1646, 1646, 1646, 1646, 1647, 1647,   35, 1647,
     1647, 1647, 1647, 1647, 1647, 1647, 1647, 1648, 1648,   18,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1649, 1649,
       17, 1649, 1649, 1649, 1649, 1649, 1649, 1649, 1649, 1650,
     1650,    0, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,

     1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1651, 1653, 1653,    0, 1653, 1653, 1653, 1653, 1653, 1653,
     1653, 1653, 1654, 1654,    0, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1655, 1655,    0, 1655, 1655, 1655, 1655,
     1655, 1655, 1655, 1655, 1656, 1656,    0, 1656, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1657, 1657,    0, 1657, 1657,
     1657, 1657, 1657, 1657, 1657, 1657, 1658, 1658,    0, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1659, 1659, 1659,
     1659, 1659,    0, 1659, 1659, 1659, 1659, 1659, 1660, 1660,
        0, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1662,

     1662, 1663, 1663, 1663, 1663,    0, 1663, 1663, 1663, 1663,
     1663, 1663, 1664, 1664, 1664, 1664, 1664,    0, 1664, 1664,
     1664, 1664, 1664, 1665, 1665,    0, 1665, 1665, 1665, 1665,
     1665, 1665, 1665, 1665, 1666, 1666, 1666, 1666, 1666, 1666,
     1666, 1666, 1666, 1666, 1666, 1667, 1667,    0, 1667, 1667,
     1667, 1667, 1667, 1667, 1667, 1667, 1668, 1668,    0, 1668,
     1668, 1668, 1668, 1668, 1668, 1668, 1668, 1669, 1669,    0,
     1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1670, 1670,
        0, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1670, 1671,
     1671,    0, 1671, 1671, 1671, 1671, 1671, 1671, 1671, 1671,

     1672, 1672,    0, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1672, 1673, 1673,    0, 1673, 1673, 1673, 1673, 1673, 1673,
     1673, 1673, 1674, 1674,    0, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1674, 1675, 1675,    0, 1675, 1675, 1675, 1675,
     1675, 1675, 1675, 1675, 1676, 1676,    0, 1676, 1676, 1676,
     1676, 1676, 1676, 1676, 1676, 1677, 1677,    0, 1677, 1677,
     1677, 1677, 1677, 1677, 1677, 1677, 1678, 1678,    0, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1679, 1679,    0,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1680, 1680,
        0, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1680, 1681,

     1681,    0, 1681, 1681, 1681, 1681, 1681, 1681, 1681, 1681,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682,
     1682, 1684, 1684, 1685, 1685, 1685, 1685, 1685, 1685, 1685,
     1685, 1685, 1685, 1685, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1686, 1686, 1687, 1687,    0, 1687, 1687,
     1687, 1687, 1687, 1687, 1687, 1687, 1688, 1688,    0, 1688,
     1688, 1688, 1688, 1688, 1688, 1688, 1688, 1689, 1689,    0,
     1689, 1689, 1689, 1689, 1689, 1689, 1689, 1689, 1690, 1690,
        0, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1690, 1691,
     1691,    0, 1691, 1691, 1691, 1691, 1691, 1691, 1691, 1691,

     1692, 1692,    0, 1692, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1693, 1693,    0, 1693, 1693, 1693, 1693, 1693, 1693,
     1693, 1693, 1694, 1694,    0, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1695, 1695,    0, 1695, 1695, 1695, 1695,
     1695, 1695, 1695, 1695, 1696, 1696,    0, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1697, 1697,    0, 1697, 1697,
     1697, 1697, 1697, 1697, 1697, 1697, 1698, 1698,    0, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1698, 1699, 1699,    0,
     1699, 1699, 1699, 1699, 1699, 1699, 1699, 1699, 1700, 1700,
        0, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1701,

     1701,    0, 1701, 1701, 1701, 1701, 1701, 1701, 1701, 1701,
     1702, 1702,    0, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1703, 1703,    0, 1703, 1703, 1703, 1703, 1703, 1703,
     1703, 1703, 1704, 1704,    0, 1704, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1705, 1705,    0, 1705, 1705, 1705, 1705,
     1705, 1705, 1705, 1705, 1706, 1706,    0, 1706, 1706, 1706,
     1706, 1706, 1706, 1706, 1706, 1707, 1707,    0, 1707, 1707,
     1707, 1707, 1707, 1707, 1707, 1707, 1708, 1708, 1708, 1708,
     1708, 1708, 1708, 1708, 1708, 1708, 1708, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1710, 1710,

     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1711,
     1711,    0, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1712, 1712,    0, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1713, 1713,    0, 1713, 1713, 1713, 1713, 1713, 1713,
     1713, 1713, 1714, 1714,    0, 1714, 1714, 1714, 1714, 1714,
     1714, 1714, 1714, 1715, 1715,    0, 1715, 1715, 1715, 1715,
     1715, 1715, 1715, 1715, 1716, 1716,    0, 1716, 1716, 1716,
     1716, 1716, 1716, 1716, 1716, 1717, 1717,    0, 1717, 1717,
     1717, 1717, 1717, 1717, 1717, 1717, 1718, 1718,    0, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1719, 1719,    0,

     1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1720,    0,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1721,
     1721,    0, 1721, 1721, 1721, 1721, 1721, 1721, 1721, 1721,
     1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722,
     1722, 1723, 1723,    0, 1723, 1723, 1723, 1723, 1723, 1723,
     1723, 1723, 1724, 1724,    0, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1725, 1725,    0, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1726, 1726,    0, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1727, 1727,    0, 1727, 1727,
     1727, 1727, 1727, 1727, 1727, 1727, 1728, 1728,    0, 1728,

     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1729, 1729,    0,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1730, 1730,
        0, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1731,
     1731,    0, 1731, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
     1732, 1732,    0, 1732, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1733, 1733,    0, 1733, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1734, 1734,    0, 1734, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1735, 1735,    0, 1735, 1735, 1735, 1735,
     1735, 1735, 1735, 1735, 1736, 1736,    0, 1736, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1737, 1737,    0, 1737, 1737,

     1737, 1737, 1737, 1737, 1737, 1737, 1738, 1738,    0, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1738, 1739, 1739,    0,
     1739, 1739, 1739, 1739, 1739, 1739, 1739, 1739, 1740, 1740,
        0, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1740, 1741,
     1741,    0, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1742, 1742,    0, 1742, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1743, 1743,    0, 1743, 1743, 1743, 1743, 1743, 1743,
     1743, 1743, 1744, 1744,    0, 1744, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1745, 1745,    0, 1745, 1745, 1745, 1745,
     1745, 1745, 1745, 1745, 1746, 1746, 1746, 1746, 1746, 1746,

     1746, 1746, 1746, 1746, 1746, 1747, 1747, 1747, 1747, 1747,
     1747, 1747, 1747, 1747, 1747, 1747, 1748, 1748, 1748, 1748,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1749, 1749,    0,
     1749, 1749, 1749, 1749, 1749, 1749, 1749, 1749, 1750, 1750,
        0, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1751,
     1751,    0, 1751, 1751, 1751, 1751, 1751, 1751, 1751, 1751,
     1752, 1752,    0, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1753, 1753,    0, 1753, 1753, 1753, 1753, 1753, 1753,
     1753, 1753, 1754, 1754,    0, 1754, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1755, 1755,    0, 1755, 1755, 1755, 1755,

     1755, 1755, 1755, 1755, 1756,    0, 1756, 1756, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1757, 1757,    0, 1757, 1757,
     1757, 1757, 1757, 1757, 1757, 1757, 1758, 1758,    0, 1758,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1759, 1759,    0,
     1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1760,    0,
     1760, 1760, 1761, 1761,    0, 1761, 1761, 1761, 1761, 1761,
     1761, 1761, 1761, 1762, 1762,    0, 1762, 1762, 1762, 1762,
     1762, 1762, 1762, 1762, 1763, 1763,    0, 1763, 1763, 1763,
     1763, 1763, 1763, 1763, 1763, 1764, 1764,    0, 1764, 1764,
     1764, 1764, 1764, 1764, 1764, 1764, 1765, 1765,    0, 1765,

     1765, 1765, 1765, 1765, 1765, 1765, 1765, 1766, 1766,    0,
     1766, 1766, 1766, 1766, 1766, 1766, 1766, 1766, 1767, 1767,
        0, 1767, 1767, 1767, 1767, 1767, 1767, 1767, 1767, 1768,
     1768,    0, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1770, 1770,    0, 1770, 1770, 1770, 1770, 1770, 1770,
     1770, 1770, 1771, 1771,    0, 1771, 1771, 1771, 1771, 1771,
     1771, 1771, 1771, 1772, 1772,    0, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772, 1774, 1774,    0, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1774, 1775, 1775,    0, 1775, 1775,

     1775, 1775, 1775, 1775, 1775, 1775, 1776, 1776, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1776, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1778, 1778,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1779,
     1779,    0, 1779, 1779, 1779, 1779, 1779, 1779, 1779, 1779,
     1780,    0, 1780,    0, 1780, 1780, 1781,    0, 1781,    0,
     1781, 1781, 1782, 1782,    0, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1784,    0, 1784, 1784, 1786, 1786,    0,
     1786, 1786, 1786, 1786, 1786, 1786, 1786, 1786, 1787, 1787,
        0, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1788,

     1788,    0, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788,
     1789,    0, 1789, 1789, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1606, 1606, 1606, 1606
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk)
 *
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "error.h"
#include "xalloc.h"

#include "gettext.h"
#define _(String) gettext (String)

#include "encodings.h"
#include "pipeline.h"
#include "sandbox.h"
#include "security.h"
#include "util.h"

#include "decompress.h"
#include "lexgrog.h"
#include "manconv.h"
#include "manconv_client.h"

#define YY_READ_BUF_SIZE	1024
#define MAX_NAME		16384

/* defines the ordered list of filters detected by lexgrog */
enum {
	TBL_FILTER = 0,	/* tbl */
	EQN_FILTER,	/* eqn */
	PIC_FILTER,	/* pic */
	GRAP_FILTER,	/* grap */
	REF_FILTER,	/* refer */
	VGRIND_FILTER,	/* vgrind */
	MAX_FILTERS	/* delimiter */
};

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static void add_str_to_whatis (const char *string, size_t length);
static void add_char_to_whatis (unsigned char c);
static void add_separator_to_whatis (void);
static void add_wordn_to_whatis (const char *string, size_t length);
static void add_word_to_whatis (const char *string);
static void add_glyph_to_whatis (const char *string, size_t length);
static void add_perldoc_to_whatis (const char *string, size_t length);
static void mdoc_text (const char *string);
static void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static bool fill_mode;
static bool waiting_for_quote;

static decompress *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = decompress_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 2987 "lexgrog.c"

#line 307 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* ИМЕ also works for mk */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 2998 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 358 "lexgrog.l"


 /* begin NAME section processing */
#line 3234 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1607 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1606 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 361 "lexgrog.l"
BEGIN (MAN_PRENAME);
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 362 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 3:
#line 367 "lexgrog.l"
case 4:
#line 368 "lexgrog.l"
case 5:
#line 369 "lexgrog.l"
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 369 "lexgrog.l"

	YY_BREAK


case 7:
#line 374 "lexgrog.l"
case 8:
#line 375 "lexgrog.l"
case 9:
/* rule 9 can match eol */
#line 376 "lexgrog.l"
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 376 "lexgrog.l"

	YY_BREAK


case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 380 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 381 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 382 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 383 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 15:
/* rule 15 can match eol */
#line 385 "lexgrog.l"
case 16:
/* rule 16 can match eol */
YY_RULE_SETUP
#line 385 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 386 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 388 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 392 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 395 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
#line 401 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 401 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 21:
/* rule 21 can match eol */
#line 410 "lexgrog.l"
case 22:
/* rule 22 can match eol */
#line 411 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 412 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 413 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 414 "lexgrog.l"
case 26:
/* rule 26 can match eol */
YY_RULE_SETUP
#line 414 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 422 "lexgrog.l"

	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 424 "lexgrog.l"
yyless (1);
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 426 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 30:
/* rule 30 can match eol */
#line 433 "lexgrog.l"
case 31:
/* rule 31 can match eol */
#line 434 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 435 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 436 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 437 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 438 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 439 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 439 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 37:
/* rule 37 can match eol */
#line 447 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 448 "lexgrog.l"
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 448 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 458 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = true;
	}
	YY_BREAK
case 41:
/* rule 41 can match eol */
#line 464 "lexgrog.l"
case 42:
/* rule 42 can match eol */
#line 465 "lexgrog.l"
case 43:
/* rule 43 can match eol */
#line 466 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 467 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 468 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 469 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 470 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 471 "lexgrog.l"
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 471 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 50:
/* rule 50 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 478 "lexgrog.l"
newline_found ();
	YY_BREAK
case 51:
/* rule 51 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 479 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 484 "lexgrog.l"
fill_mode = false;
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 485 "lexgrog.l"
fill_mode = true;
	YY_BREAK

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 488 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 55:
/* rule 55 can match eol */
#line 493 "lexgrog.l"
case 56:
/* rule 56 can match eol */
#line 494 "lexgrog.l"
case 57:
/* rule 57 can match eol */
#line 495 "lexgrog.l"
case 58:
/* rule 58 can match eol */
#line 496 "lexgrog.l"
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 496 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 501 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 505 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 506 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 507 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 508 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 509 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 510 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 511 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 512 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 515 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 516 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 518 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 521 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 523 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 524 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 526 "lexgrog.l"
/* comment */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 528 "lexgrog.l"
/* font changes */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 529 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 531 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 532 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 534 "lexgrog.l"
/* size changes */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 535 "lexgrog.l"
/* width of string */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 537 "lexgrog.l"
/* catch all */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 539 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 546 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 547 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 548 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 549 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 550 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 551 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 552 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 554 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 93:
YY_RULE_SETUP
#line 561 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 562 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 563 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 564 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 565 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 566 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 567 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 568 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 569 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 570 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 571 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 572 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 573 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 574 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 107:
YY_RULE_SETUP
#line 581 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 586 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 109:
YY_RULE_SETUP
#line 593 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 594 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 595 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 596 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 601 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 114:
YY_RULE_SETUP
#line 608 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 612 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 616 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 620 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 624 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 119:
YY_RULE_SETUP
#line 630 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 120:
YY_RULE_SETUP
#line 637 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 642 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 122:
YY_RULE_SETUP
#line 649 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 654 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 124:
YY_RULE_SETUP
#line 661 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 666 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 673 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 127:
/* rule 127 can match eol */
#line 680 "lexgrog.l"
case 128:
/* rule 128 can match eol */
#line 681 "lexgrog.l"
case 129:
/* rule 129 can match eol */
#line 682 "lexgrog.l"
case 130:
/* rule 130 can match eol */
#line 683 "lexgrog.l"
case 131:
/* rule 131 can match eol */
#line 684 "lexgrog.l"
case 132:
/* rule 132 can match eol */
#line 685 "lexgrog.l"
case 133:
/* rule 133 can match eol */
#line 686 "lexgrog.l"
case 134:
/* rule 134 can match eol */
YY_RULE_SETUP
#line 686 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 693 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 136:
YY_RULE_SETUP
#line 699 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 137:
/* rule 137 can match eol */
#line 703 "lexgrog.l"
case 138:
/* rule 138 can match eol */
YY_RULE_SETUP
#line 703 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 705 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 710 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 713 "lexgrog.l"
return 1;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 715 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4178 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1607 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1607 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1606);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 715 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
}

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = false;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = false;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret = 0;
	decompress *d;
	char *page_encoding = NULL;
	bool run_col = p_lg->type == CATPAGE && *PROG_COL != '\0';

	if (strcmp (file, "-") == 0) {
		d = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		int decompress_flags;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		decompress_flags = 0;
		/* If we're looking at a cat page, then we need to run col
		 * over it, which doesn't work conveniently with an
		 * in-process decompressor.
		 */
		if (!run_col)
			decompress_flags |= DECOMPRESS_ALLOW_INPROCESS;
		d = decompress_open (file, decompress_flags);
		if (!d) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding) {
		if (decompress_is_pipeline (d))
			add_manconv (decompress_get_pipeline (d),
				     page_encoding, "UTF-8");
		else if (manconv_inprocess (d, page_encoding, "UTF-8") != 0)
			/* manconv should already have written to stderr, so
			 * just return zero (i.e. no result).
			 */
			goto out;
	}
	if (run_col) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args
			(PROG_COL, "-b", "-p", "-x", nullptr);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (decompress_get_pipeline (d), col_cmd);
	}
	decompress_start (d);

	ret = find_name_decompressed (d, filename, p_lg);

out:
	free (page_encoding);
	decompress_free (d);
	return ret;
}

int find_name_decompressed (decompress *d, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = d;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = true;
	waiting_for_quote = false;

	if (p_lg->type == CATPAGE)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	decompress_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

